=== modified file 'Makefile.am'
--- Makefile.am	2009-05-04 18:02:55 +0000
+++ Makefile.am	2009-05-08 19:07:39 +0000
@@ -81,6 +81,7 @@
 		mysys/iocache.h \
 		mysys/my_alloc.h \
 		mysys/my_bit.h \
+		mysys/my_bitmap.h \
 		mysys/my_dir.h \
 		mysys/my_getopt.h \
 		mysys/my_pthread.h \
@@ -142,6 +143,7 @@
 		mysys/my_access.cc \
 		mysys/my_alloc.cc \
 		mysys/my_bit.cc \
+		mysys/my_bitmap.cc \
 		mysys/my_copy.cc \
 		mysys/my_create.cc \
 		mysys/my_delete.cc \

=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-04-28 07:29:32 +0000
+++ drizzled/Makefile.am	2009-05-08 19:07:39 +0000
@@ -247,7 +247,6 @@
 		item/type_holder.h \
 		item/uint.h \
 		key.h \
-		key_map.h \
 		key_part_spec.h \
 		korr.h \
 		lex_column.h \
@@ -565,7 +564,6 @@
 		item/uint.cc \
 		item.cc \
 		key.cc \
-		key_map.cc \
 		lock.cc \
 		logging.cc \
 		lookup_symbol.cc \

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2009-04-28 07:29:32 +0000
+++ drizzled/drizzled.cc	2009-05-08 19:07:39 +0000
@@ -2772,7 +2772,7 @@
   drizzled_user= drizzled_chroot= 0;
   my_bind_addr_str= NULL;
   memset(&global_status_var, 0, sizeof(global_status_var));
-  key_map_full.set();
+  key_map_full.set_all();
 
   /* Character sets */
   system_charset_info= &my_charset_utf8_general_ci;

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2009-05-04 23:54:28 +0000
+++ drizzled/field.cc	2009-05-08 19:07:39 +0000
@@ -823,7 +823,8 @@
    key_start(0), part_of_key(0), part_of_key_not_clustered(0),
    part_of_sortkey(0), unireg_check(unireg_check_arg),
    field_length(length_arg), null_bit(null_bit_arg),
-   is_created_from_null_item(false)
+   is_created_from_null_item(false),
+   is_stored(true)
 {
   flags=null_ptr ? 0: NOT_NULL_FLAG;
   comment.str= (char*) "";
@@ -1181,9 +1182,9 @@
   if (tmp->table->maybe_null)
     tmp->flags&= ~NOT_NULL_FLAG;
   tmp->table= new_table;
-  tmp->key_start.reset();
-  tmp->part_of_key.reset();
-  tmp->part_of_sortkey.reset();
+  tmp->key_start.init(0);
+  tmp->part_of_key.init(0);
+  tmp->part_of_sortkey.init(0);
   tmp->unireg_check= Field::NONE;
   tmp->flags&= (NOT_NULL_FLAG | BLOB_FLAG | UNSIGNED_FLAG | BINARY_FLAG | ENUM_FLAG | SET_FLAG);
   tmp->reset_fields();
@@ -1317,6 +1318,7 @@
               ((decimals_arg & FIELDFLAG_MAX_DEC) << FIELDFLAG_DEC_SHIFT) |
               (maybe_null ? FIELDFLAG_MAYBE_NULL : 0) |
               (is_unsigned ? 0 : FIELDFLAG_DECIMAL));
+  is_stored= true;
 }
 
 
@@ -1379,6 +1381,7 @@
   interval_list.empty();
 
   comment= *fld_comment;
+  is_stored= true;
 
   /*
     Set NO_DEFAULT_VALUE_FLAG if this field doesn't have a default value and
@@ -1738,6 +1741,7 @@
   charset=    old_field->charset();		// May be NULL ptr
   comment=    old_field->comment;
   decimals=   old_field->decimals();
+  is_stored= old_field->is_stored;
 
   /* Fix if the original table had 4 byte pointer blobs */
   if (flags & BLOB_FLAG)
@@ -1929,14 +1933,3 @@
   }
 }
 
-bool Field::isRead() 
-{ 
-  return table->read_set->test(field_index); 
-}
-
-
-bool Field::isWrite()
-{ 
-  return table->write_set->test(field_index); 
-}
-

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2009-05-04 23:54:28 +0000
+++ drizzled/field.h	2009-05-08 19:07:39 +0000
@@ -27,7 +27,6 @@
 
 #include <drizzled/sql_error.h>
 #include <drizzled/my_decimal.h>
-#include <drizzled/key_map.h>
 #include <drizzled/sql_bitmap.h>
 #include <drizzled/sql_list.h>
 /* System-wide common data structures */
@@ -112,6 +111,13 @@
    */
   bool is_created_from_null_item;
 
+  /*
+    Indication that the field is physically stored in tables
+    rather than just generated on SQL queries.
+    As of now, false can only be set for generated-only virtual columns.
+  */
+  bool is_stored;
+
   Field(unsigned char *ptr_arg,uint32_t length_arg,unsigned char *null_ptr_arg,
         unsigned char null_bit_arg, utype unireg_check_arg,
         const char *field_name_arg);
@@ -519,9 +525,6 @@
   friend class Item_sum_max;
   friend class Item_func_group_concat;
 
-  bool isRead();
-  bool isWrite();
-
 private:
   /*
     Primitive for implementing last_null_byte().
@@ -576,6 +579,8 @@
   uint32_t  decimals, flags, pack_length, key_length;
   Field::utype unireg_check;
   TYPELIB *interval;			// Which interval to use
+  TYPELIB *save_interval;               // Temporary copy for the above
+                                        // Used only for UCS2 intervals
   List<String> interval_list;
   const CHARSET_INFO *charset;
   Field *field;				// For alter table
@@ -583,6 +588,13 @@
   uint8_t       interval_id;	// For rea_create_table
   uint32_t	offset,pack_flag;
 
+  /*
+    Indication that the field is phycically stored in tables
+    rather than just generated on SQL queries.
+    As of now, FALSE can only be set for generated-only virtual columns.
+  */
+  bool is_stored;
+
   Create_field() :after(0) {}
   Create_field(Field *field, Field *orig_field);
   /* Used to make a clone of this object for ALTER/CREATE TABLE */

=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2009-05-04 21:06:03 +0000
+++ drizzled/handler.cc	2009-05-08 19:07:39 +0000
@@ -1496,6 +1496,24 @@
 
 
 /**
+  MySQL signal that it changed the column bitmap
+
+  This is for handlers that needs to setup their own column bitmaps.
+  Normally the handler should set up their own column bitmaps in
+  index_init() or rnd_init() and in any column_bitmaps_signal() call after
+  this.
+
+  The handler is allowed to do changes to the bitmap after a index_init or
+  rnd_init() call is made as after this, MySQL will not use the bitmap
+  for any program logic checking.
+*/
+void handler::column_bitmaps_signal()
+{
+  return;
+}
+
+
+/**
   Reserves an interval of auto_increment values from the handler.
 
   offset and increment means that we want values to be of the form
@@ -1522,6 +1540,7 @@
   (void) extra(HA_EXTRA_KEYREAD);
   table->mark_columns_used_by_index_no_reset(table->s->next_number_index,
                                         table->read_set);
+  column_bitmaps_signal();
   index_init(table->s->next_number_index, 1);
   if (table->s->next_number_keypart == 0)
   {						// Autoincrement at key-start
@@ -3028,7 +3047,7 @@
   KEY_PART_INFO *kp_end= kp + table->key_info[keyno].key_parts;
   for (; kp != kp_end; kp++)
   {
-    if (!kp->field->part_of_key.test(keyno))
+    if (!kp->field->part_of_key.is_set(keyno))
       return true;
   }
   return false;

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2009-05-04 21:06:03 +0000
+++ drizzled/handler.h	2009-05-08 19:07:39 +0000
@@ -36,7 +36,6 @@
 
 /* Bits to show what an alter table will do */
 #include <drizzled/sql_bitmap.h>
-#include <drizzled/key_map.h>
 
 #include<bitset>
 
@@ -374,6 +373,14 @@
   { assert(0); return "";}
 
 
+  /**
+    Signal that the table->read_set and table->write_set table maps changed
+    The handler is allowed to set additional bits in the above map in this
+    call. Normally the handler should ignore all calls until we have done
+    a ha_rnd_init() or ha_index_init(), write_row(), update_row or delete_row()
+    as there may be several calls to this routine.
+  */
+  virtual void column_bitmaps_signal();
   uint32_t get_index(void) const { return active_index; }
   virtual int close(void)=0;
 

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2009-04-17 02:52:53 +0000
+++ drizzled/item.h	2009-05-08 19:07:39 +0000
@@ -22,7 +22,6 @@
 
 #include <drizzled/dtcollation.h>
 #include <mysys/drizzle_time.h>
-#include <drizzled/key_map.h>
 #include <drizzled/my_decimal.h>
 #include <drizzled/sql_bitmap.h>
 #include <drizzled/sql_list.h>

=== modified file 'drizzled/item/field.cc'
--- drizzled/item/field.cc	2009-04-28 07:29:32 +0000
+++ drizzled/item/field.cc	2009-05-08 19:07:39 +0000
@@ -931,7 +931,7 @@
         /* First usage of column */
         table->used_fields++;                     // Used to optimize loops
         /* purecov: begin inspected */
-        table->covering_keys&= field->part_of_key;
+        table->covering_keys.intersect(field->part_of_key);
         /* purecov: end */
       }
     }

=== modified file 'drizzled/key.cc'
--- drizzled/key.cc	2009-04-16 22:50:29 +0000
+++ drizzled/key.cc	2009-05-08 19:07:39 +0000
@@ -394,7 +394,7 @@
 {
   table->tmp_set.reset();
   table->mark_columns_used_by_index_no_reset(idx, &table->tmp_set);
-  if (isBitmapOverlapping(*fields, table->tmp_set))
+  if (isBitmapOverlapping(fields, &table->tmp_set))
     return 1;
 
   /*

=== modified file 'drizzled/key_map.cc'
--- drizzled/key_map.cc	2009-04-17 04:04:06 +0000
+++ drizzled/key_map.cc	2009-05-08 19:07:39 +0000
@@ -21,12 +21,25 @@
 
 #include <drizzled/key_map.h>
 
-bool is_keymap_prefix(const key_map& map, const uint32_t prefix_size)
+bool is_subset(const key_map& map, const key_map& map2)
+{
+
+  size_t count;
+  for (count= 0; count < map.size(); count++)
+  {
+    if (map[count] & ~map2[count])
+      return true;
+  }
+  return false;
+
+}
+
+bool is_prefix(const key_map& map, const uint32_t prefix_size)
 {
   size_t pos= 0;
 
   for (; pos < prefix_size; pos++)
-    if (! map.test(pos))
+    if (map[pos] == false)
       return false;
 
   /*TODO: huh?
@@ -36,22 +49,12 @@
   */
 
   for (; pos < map.size(); pos++)
-    if (map.test(pos))
+    if (map[pos] == true)
       return false;
 
   return true;
 }
 
-void set_prefix(key_map& map, const uint32_t prefix_size)
-{
-  size_t pos= 0;
-
-  for (; pos < prefix_size && pos < map.size(); pos++)
-  {
-    map.set(pos);
-  }
-}
-
 bool is_overlapping(const key_map& map, const key_map& map2)
 {
   size_t count;
@@ -62,9 +65,3 @@
   }
   return true;
 }
-
-void key_map_subtract(key_map& map1, key_map& map2)
-{
-  map1&= map2.flip();
-  map2.flip();
-}

=== modified file 'drizzled/key_map.h'
--- drizzled/key_map.h	2009-04-17 04:04:06 +0000
+++ drizzled/key_map.h	2009-05-08 19:07:39 +0000
@@ -20,25 +20,17 @@
 #ifndef DRIZZLED_KEY_MAP_H
 #define DRIZZLED_KEY_MAP_H
 
-#include <drizzled/global.h>
-#include <drizzled/definitions.h>
-
 #include <bitset>
 
 /* Used for finding keys */
 #if MAX_INDEXES <= 64
-typedef std::bitset<72> key_map;
+typedef std::bitset<64>  key_map;
 #else
 typedef std::bitset<((MAX_INDEXES+7)/8*8)> key_map;
 #endif
 
-/* useful constants */
-extern const key_map key_map_empty;
-extern key_map key_map_full;          /* Should be threaded as const */
-
-bool is_keymap_prefix(const key_map& map, const uint32_t n);
+bool is_subset(const key_map& map, const key_map& map2);
+bool is_prefix(const key_map& map, const uint32_t n);
 bool is_overlapping(const key_map& map, const key_map& map2);
-void set_prefix(key_map& map, const uint32_t n);
-void key_map_subtract(key_map& map1, key_map& map2);
 
 #endif

=== modified file 'drizzled/opt_range.cc'
--- drizzled/opt_range.cc	2009-04-17 14:34:37 +0000
+++ drizzled/opt_range.cc	2009-05-08 19:07:39 +0000
@@ -619,7 +619,7 @@
   SEL_TREE(enum Type type_arg) :type(type_arg) {}
   SEL_TREE() :type(KEY)
   {
-    keys_map.reset();
+    keys_map.clear_all();
     memset(keys, 0, sizeof(keys));
   }
   /*
@@ -633,7 +633,7 @@
 
   /*
     Possible ways to read rows using index_merge. The list is non-empty only
-    if type==KEY. Currently can be non empty only if keys_map.none().
+    if type==KEY. Currently can be non empty only if keys_map.is_clear_all().
   */
   List<SEL_IMERGE> merges;
 
@@ -1044,8 +1044,7 @@
 
 SQL_SELECT::SQL_SELECT() :quick(0),cond(0),free_cond(0)
 {
-  quick_keys.reset(); 
-  needed_reg.reset();
+  quick_keys.clear_all(); needed_reg.clear_all();
   my_b_clear(&file);
 }
 
@@ -1074,7 +1073,7 @@
                              ha_rows limit)
 {
   key_map tmp;
-  tmp.set();
+  tmp.set_all();
   return test_quick_select(session, tmp, 0, limit,
                            force_quick_range, false) < 0;
 }
@@ -1826,7 +1825,7 @@
 
   for (idx= 0; idx < table->s->keys; idx++)
   {
-    if (!(table->keys_in_use_for_query.test(idx)))
+    if (!(table->keys_in_use_for_query.is_set(idx)))
       continue;
     KEY_PART_INFO *keyinfo= table->key_info[idx].key_part;
     uint32_t n_parts=  table->key_info[idx].key_parts;
@@ -2181,9 +2180,9 @@
   double scan_time;
   delete quick;
   quick=0;
-  needed_reg.reset();
-  quick_keys.reset();
-  if (keys_to_use.none())
+  needed_reg.clear_all();
+  quick_keys.clear_all();
+  if (keys_to_use.is_clear_all())
     return 0;
   records= head->file->stats.records;
   if (!records)
@@ -2197,8 +2196,8 @@
   else if (read_time <= 2.0 && !force_quick_range)
     return 0;				/* No need for quick select */
 
-  keys_to_use&= head->keys_in_use_for_query;
-  if (keys_to_use.any())
+  keys_to_use.intersect(head->keys_in_use_for_query);
+  if (!keys_to_use.is_clear_all())
   {
     MEM_ROOT alloc;
     SEL_TREE *tree= NULL;
@@ -2212,8 +2211,8 @@
     /* set up parameter that is passed to all functions */
     param.session= session;
     param.baseflag= head->file->ha_table_flags();
-    param.prev_tables= prev_tables | const_tables;
-    param.read_tables= read_tables;
+    param.prev_tables=prev_tables | const_tables;
+    param.read_tables=read_tables;
     param.current_table= head->map;
     param.table=head;
     param.keys=0;
@@ -2247,7 +2246,7 @@
     for (idx=0 ; idx < head->s->keys ; idx++, key_info++)
     {
       KEY_PART_INFO *key_part_info;
-      if (! keys_to_use.test(idx))
+      if (!keys_to_use.is_set(idx))
 	continue;
 
       param.key[param.keys]=key_parts;
@@ -2271,7 +2270,7 @@
     param.alloced_sel_args= 0;
 
     /* Calculate cost of full index read for the shortest covering index */
-    if (!head->covering_keys.none())
+    if (!head->covering_keys.is_clear_all())
     {
       int key_for_use= head->find_shortest_key(&head->covering_keys);
       double key_read_time=
@@ -2756,6 +2755,7 @@
 ROR_SCAN_INFO *make_ror_scan(const PARAM *param, int idx, SEL_ARG *sel_arg)
 {
   ROR_SCAN_INFO *ror_scan;
+  my_bitmap_map *bitmap_buf;
   uint32_t keynr;
 
   if (!(ror_scan= (ROR_SCAN_INFO*)alloc_root(param->mem_root,
@@ -2768,6 +2768,11 @@
                              param->table->file->ref_length);
   ror_scan->sel_arg= sel_arg;
   ror_scan->records= param->table->quick_rows[keynr];
+
+  if (!(bitmap_buf= (my_bitmap_map*) alloc_root(param->mem_root,
+                                                param->fields_bitmap_size)))
+    return NULL;
+
   ror_scan->covered_fields.reset();
 
   KEY_PART_INFO *key_part= param->table->key_info[keynr].key_part;
@@ -3240,7 +3245,7 @@
   for (idx= 0, cur_ror_scan= tree->ror_scans; idx < param->keys; idx++)
   {
     ROR_SCAN_INFO *scan;
-    if (! tree->ror_scans_map.test(idx))
+    if (!tree->ror_scans_map.is_set(idx))
       continue;
     if (!(scan= make_ror_scan(param, idx, tree->keys[idx])))
       return NULL;
@@ -3545,7 +3550,7 @@
     is defined as "not null".
   */
   print_sel_tree(param, tree, &tree->keys_map, "tree scans");
-  tree->ror_scans_map.reset();
+  tree->ror_scans_map.clear_all();
   tree->n_ror_scans= 0;
   for (idx= 0,key=tree->keys, end=key+param->keys; key != end; key++,idx++)
   {
@@ -3558,10 +3563,10 @@
       uint32_t keynr= param->real_keynr[idx];
       if ((*key)->type == SEL_ARG::MAYBE_KEY ||
           (*key)->maybe_flag)
-        param->needed_reg->set(keynr);
+        param->needed_reg->set_bit(keynr);
 
       bool read_index_only= index_read_must_be_used ||
-                            param->table->covering_keys.test(keynr);
+                            param->table->covering_keys.is_set(keynr);
 
       found_records= check_quick_select(param, idx, read_index_only, *key,
                                         update_tbl_stats, &mrr_flags,
@@ -3570,7 +3575,7 @@
       if ((found_records != HA_POS_ERROR) && param->is_ror_scan)
       {
         tree->n_ror_scans++;
-        tree->ror_scans_map.set(idx);
+        tree->ror_scans_map.set_bit(idx);
       }
       if (read_time > found_read_time && found_records != HA_POS_ERROR)
       {
@@ -3591,7 +3596,7 @@
                                                     best_mrr_flags)))
     {
       read_plan->records= best_records;
-      read_plan->is_ror= tree->ror_scans_map.test(idx);
+      read_plan->is_ror= tree->ror_scans_map.is_set(idx);
       read_plan->read_cost= read_time;
       read_plan->mrr_buf_size= best_buf_size;
     }
@@ -4298,7 +4303,7 @@
       }
       sel_arg->part=(unsigned char) key_part->part;
       tree->keys[key_part->key]=sel_add(tree->keys[key_part->key],sel_arg);
-      tree->keys_map.set(key_part->key);
+      tree->keys_map.set_bit(key_part->key);
     }
   }
 
@@ -4787,7 +4792,7 @@
     return(tree1);
   }
   key_map  result_keys;
-  result_keys.reset();
+  result_keys.clear_all();
 
   /* Join the trees key per key */
   SEL_ARG **key1,**key2,**end;
@@ -4807,7 +4812,7 @@
 	tree1->type= SEL_TREE::IMPOSSIBLE;
         return(tree1);
       }
-      result_keys.set(key1 - tree1->keys);
+      result_keys.set_bit(key1 - tree1->keys);
 #ifdef EXTRA_DEBUG
         if (*key1 && param->alloced_sel_args < SEL_ARG::MAX_SEL_ARGS)
           (*key1)->test_use_count(*key1);
@@ -4816,7 +4821,7 @@
   }
   tree1->keys_map= result_keys;
   /* dispose index_merge if there is a "range" option */
-  if (result_keys.any())
+  if (!result_keys.is_clear_all())
   {
     tree1->merges.empty();
     return(tree1);
@@ -4838,16 +4843,16 @@
                            RANGE_OPT_PARAM* param)
 {
   key_map common_keys= tree1->keys_map;
-  common_keys&= tree2->keys_map;
+  common_keys.intersect(tree2->keys_map);
 
-  if (common_keys.none())
+  if (common_keys.is_clear_all())
     return false;
 
   /* trees have a common key, check if they refer to same key part */
   SEL_ARG **key1,**key2;
   for (uint32_t key_no=0; key_no < param->keys; key_no++)
   {
-    if (common_keys.test(key_no))
+    if (common_keys.is_set(key_no))
     {
       key1= tree1->keys + key_no;
       key2= tree2->keys + key_no;
@@ -4926,7 +4931,7 @@
       if (tree->keys[i]->part)
       {
         tree->keys[i]= NULL;
-        tree->keys_map.reset(i);
+        tree->keys_map.clear_bit(i);
       }
       else
         res= true;
@@ -4952,7 +4957,7 @@
 
   SEL_TREE *result= 0;
   key_map  result_keys;
-  result_keys.reset();
+  result_keys.clear_all();
   if (sel_trees_can_be_ored(tree1, tree2, param))
   {
     /* Join the trees key per key */
@@ -4964,7 +4969,7 @@
       if (*key1)
       {
         result=tree1;				// Added to tree1
-        result_keys.set(key1 - tree1->keys);
+        result_keys.set_bit(key1 - tree1->keys);
 #ifdef EXTRA_DEBUG
         if (param->alloced_sel_args < SEL_ARG::MAX_SEL_ARGS)
           (*key1)->test_use_count(*key1);
@@ -6309,7 +6314,7 @@
     param->table->quick_rows[keynr]=rows;
     if (update_tbl_stats)
     {
-      param->table->quick_keys.set(keynr);
+      param->table->quick_keys.set_bit(keynr);
       param->table->quick_key_parts[keynr]=param->max_key_part+1;
       param->table->quick_n_ranges[keynr]= param->range_count;
       param->table->quick_condition_rows=
@@ -8041,7 +8046,7 @@
        cur_index_info++, cur_index++)
   {
     /* Check (B1) - if current index is covering. */
-    if (!table->covering_keys.test(cur_index))
+    if (!table->covering_keys.is_set(cur_index))
       goto next_index;
 
     /*
@@ -8065,7 +8070,7 @@
           part of 'cur_index'
         */
         if (table->read_set->test(cur_field->field_index) &&
-            !cur_field->part_of_key_not_clustered.test(cur_index))
+            !cur_field->part_of_key_not_clustered.is_set(cur_index))
           goto next_index;                  // Field was not part of key
       }
     }
@@ -8109,7 +8114,7 @@
     else if (join->select_distinct)
     {
       select_items_it.rewind();
-      cur_used_key_parts.reset();
+      cur_used_key_parts.clear_all();
       uint32_t max_key_part= 0;
       while ((item= select_items_it++))
       {
@@ -8120,13 +8125,13 @@
           Check if this attribute was already present in the select list.
           If it was present, then its corresponding key part was alredy used.
         */
-        if (cur_used_key_parts.test(key_part_nr))
+        if (cur_used_key_parts.is_set(key_part_nr))
           continue;
         if (key_part_nr < 1 || key_part_nr > join->fields_list.elements)
           goto next_index;
         cur_part= cur_index_info->key_part + key_part_nr - 1;
         cur_group_prefix_len+= cur_part->store_length;
-        cur_used_key_parts.set(key_part_nr);
+        cur_used_key_parts.set_bit(key_part_nr);
         ++cur_group_key_parts;
         max_key_part= cmax(max_key_part,key_part_nr);
       }
@@ -8136,10 +8141,9 @@
         all_parts have all bits set from 0 to (max_key_part-1).
         cur_parts have bits set for only used keyparts.
       */
-      key_map all_parts, cur_parts;
-      for (uint32_t pos= 0; pos < max_key_part; pos++)
-        all_parts.set(pos);
-      cur_parts= cur_used_key_parts >> 1;
+      uint64_t all_parts, cur_parts;
+      all_parts= (1<<max_key_part) - 1;
+      cur_parts= cur_used_key_parts.to_uint64_t() >> 1;
       if (all_parts != cur_parts)
         goto next_index;
     }
@@ -9841,7 +9845,7 @@
        key != end ;
        key++,idx++)
   {
-    if (tree_map->test(idx))
+    if (tree_map->is_set(idx))
     {
       uint32_t keynr= param->real_keynr[idx];
       if (tmp.length())

=== modified file 'drizzled/opt_sum.cc'
--- drizzled/opt_sum.cc	2009-04-17 00:15:54 +0000
+++ drizzled/opt_sum.cc	2009-05-08 19:07:39 +0000
@@ -818,7 +818,7 @@
       Perform a check if index is not disabled by ALTER Table
       or IGNORE INDEX.
     */
-    if (!table->keys_in_use_for_query.test(idx))
+    if (!table->keys_in_use_for_query.is_set(idx))
       continue;
     uint32_t jdx= 0;
     *prefix_len= 0;
@@ -874,7 +874,7 @@
             The following test is false when the key in the key tree is
             converted (for example to upper case)
           */
-          if (field->part_of_key.test(idx))
+          if (field->part_of_key.is_set(idx))
           {
             table->key_read= 1;
             table->file->extra(HA_EXTRA_KEYREAD);

=== modified file 'drizzled/order.h'
--- drizzled/order.h	2009-04-17 02:52:53 +0000
+++ drizzled/order.h	2009-05-08 19:07:39 +0000
@@ -21,7 +21,6 @@
 #define DRIZZLED_ORDER_H
 
 #include <drizzled/sql_bitmap.h>
-#include <drizzled/key_map.h>
 #include <drizzled/field.h>
 
 /* Order clause list element */

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-04-29 07:16:04 +0000
+++ drizzled/show.cc	2009-05-08 19:07:39 +0000
@@ -3275,7 +3275,7 @@
         uint32_t flags= key_part->field ? key_part->field->flags : 0;
         const char *pos=(char*) ((flags & NOT_NULL_FLAG) ? "" : "YES");
         table->field[12]->store(pos, strlen(pos), cs);
-        if (!show_table->s->keys_in_use.test(i))
+        if (!show_table->s->keys_in_use.is_set(i))
           table->field[14]->store(STRING_WITH_LEN("disabled"), cs);
         else
           table->field[14]->store("", 0, cs);

=== modified file 'drizzled/sj_tmp_table.cc'
--- drizzled/sj_tmp_table.cc	2009-04-29 07:16:04 +0000
+++ drizzled/sj_tmp_table.cc	2009-05-08 19:07:39 +0000
@@ -62,7 +62,7 @@
   MEM_ROOT *mem_root_save, own_root;
   Table *table;
   TableShare *share;
-  uint32_t temp_pool_slot= BIT_NONE;
+  uint32_t temp_pool_slot= MY_BIT_NONE;
   char  *tmpname,path[FN_REFLEN];
   Field **reg_field;
   KEY_PART_INFO *key_part_info;
@@ -83,7 +83,7 @@
   if (use_temp_pool && !(test_flags & TEST_KEEP_TMP_TABLES))
     temp_pool_slot = setNextBit(temp_pool);
 
-  if (temp_pool_slot != BIT_NONE) // we got a slot
+  if (temp_pool_slot != MY_BIT_NONE) // we got a slot
     sprintf(path, "%s_%lx_%i", TMP_FILE_PREFIX,
 	    (unsigned long)current_pid, temp_pool_slot);
   else
@@ -112,9 +112,10 @@
                         &tmpname, (uint32_t) strlen(path)+1,
                         &group_buff, (!using_unique_constraint ?
                                       uniq_tuple_length_arg : 0),
+                        &bitmaps, bitmap_buffer_size(1)*2,
                         NULL))
   {
-    if (temp_pool_slot != BIT_NONE)
+    if (temp_pool_slot != MY_BIT_NONE)
       temp_pool.reset(temp_pool_slot);
     return(NULL);
   }
@@ -136,9 +137,9 @@
   table->temp_pool_slot = temp_pool_slot;
   table->copy_blobs= 1;
   table->in_use= session;
-  table->quick_keys.reset();
-  table->covering_keys.reset();
-  table->keys_in_use_for_query.reset();
+  table->quick_keys.init();
+  table->covering_keys.init();
+  table->keys_in_use_for_query.init();
 
   table->s= share;
   share->init(tmpname, tmpname);
@@ -147,8 +148,8 @@
   share->db_low_byte_first=1;                // True for HEAP and MyISAM
   share->table_charset= NULL;
   share->primary_key= MAX_KEY;               // Indicate no primary key
-  share->keys_for_keyread.reset();
-  share->keys_in_use.reset();
+  share->keys_for_keyread.init();
+  share->keys_in_use.init();
 
   blob_count= 0;
 
@@ -162,9 +163,9 @@
     if (!field)
       return(0);
     field->table= table;
-    field->key_start.reset();
-    field->part_of_key.reset();
-    field->part_of_sortkey.reset();
+    field->key_start.init(0);
+    field->part_of_key.init(0);
+    field->part_of_sortkey.init(0);
     field->unireg_check= Field::NONE;
     field->flags= (NOT_NULL_FLAG | BINARY_FLAG | NO_DEFAULT_VALUE_FLAG);
     field->reset_fields();
@@ -326,7 +327,7 @@
 err:
   session->mem_root= mem_root_save;
   table->free_tmp_table(session);                    /* purecov: inspected */
-  if (temp_pool_slot != BIT_NONE)
+  if (temp_pool_slot != MY_BIT_NONE)
     temp_pool.reset(temp_pool_slot);
   return(NULL);        /* purecov: inspected */
 }

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-05-04 18:52:14 +0000
+++ drizzled/sql_base.cc	2009-05-08 19:07:39 +0000
@@ -883,7 +883,7 @@
 {
   for (Table *table= session->temporary_tables ; table ; table= table->next)
   {
-    if ((table->query_id == session->query_id))
+    if ((table->query_id == session->query_id) && ! table->open_by_handler)
     {
       table->query_id= 0;
       table->file->ha_reset();
@@ -3563,8 +3563,8 @@
       been set for all fields (for example for view).
     */
 
-    table->covering_keys&= field->part_of_key;
-    table->merge_keys|= field->part_of_key;
+    table->covering_keys.intersect(field->part_of_key);
+    table->merge_keys.merge(field->part_of_key);
 
     if (session->mark_used_columns == MARK_COLUMNS_READ)
     {
@@ -4645,16 +4645,16 @@
         Table *table_1= nj_col_1->table_ref->table;
         /* Mark field_1 used for table cache. */
         table_1->read_set->set(field_1->field_index);
-        table_1->covering_keys&= field_1->part_of_key;
-        table_1->merge_keys|= field_1->part_of_key;
+        table_1->covering_keys.intersect(field_1->part_of_key);
+        table_1->merge_keys.merge(field_1->part_of_key);
       }
       if (field_2)
       {
         Table *table_2= nj_col_2->table_ref->table;
         /* Mark field_2 used for table cache. */
         table_2->read_set->set(field_2->field_index);
-        table_2->covering_keys&= field_2->part_of_key;
-        table_2->merge_keys|= field_2->part_of_key;
+        table_2->covering_keys.intersect(field_2->part_of_key);
+        table_2->merge_keys.merge(field_2->part_of_key);
       }
 
       if (using_fields != NULL)
@@ -5332,7 +5332,7 @@
   String *name;
   uint32_t pos;
 
-  map->reset();
+  map->clear_all();
   while ((name=it++))
   {
     if (table->s->keynames.type_names == 0 ||
@@ -5342,10 +5342,10 @@
     {
       my_error(ER_KEY_DOES_NOT_EXITS, MYF(0), name->c_ptr(),
 	       table->pos_in_table_list->alias);
-      map->set();
+      map->set_all();
       return 1;
     }
-    map->set(pos-1);
+    map->set_bit(pos-1);
   }
   return 0;
 }
@@ -5449,8 +5449,8 @@
         field->table->read_set->set(field->field_index);
         if (table)
         {
-          table->covering_keys&= field->part_of_key;
-          table->merge_keys|= field->part_of_key;
+          table->covering_keys.intersect(field->part_of_key);
+          table->merge_keys.merge(field->part_of_key);
         }
         if (tables->is_natural_join)
         {
@@ -5467,8 +5467,8 @@
           if (field_table)
           {
             session->used_tables|= field_table->map;
-            field_table->covering_keys&= field->part_of_key;
-            field_table->merge_keys|= field->part_of_key;
+            field_table->covering_keys.intersect(field->part_of_key);
+            field_table->merge_keys.merge(field->part_of_key);
             field_table->used_fields++;
           }
         }

=== modified file 'drizzled/sql_bitmap.cc'
--- drizzled/sql_bitmap.cc	2009-04-17 02:13:52 +0000
+++ drizzled/sql_bitmap.cc	2009-05-08 19:07:39 +0000
@@ -29,7 +29,7 @@
  * bitsets and methods for thread-safe bitsets.
  */
 
-#include <drizzled/sql_bitmap.h>
+#include "drizzled/sql_bitmap.h"
 
 #include <bitset>
 
@@ -38,14 +38,14 @@
 uint32_t setNextBit(bitset<MAX_FIELDS> &bitmap)
 {
   uint32_t bit_found;
-  if ((bit_found= getFirstBitPos(bitmap)) != BIT_NONE)
+  if ((bit_found= getFirstBitPos(bitmap)) != MY_BIT_NONE)
     bitmap.set(bit_found);
   return bit_found;
 }
 
 uint32_t getFirstBitPos(const bitset<MAX_FIELDS> &bitmap)
 {
-  uint32_t first_bit= BIT_NONE;
+  uint32_t first_bit= MY_BIT_NONE;
   for (int idx= 0; idx < MAX_FIELDS; idx++)
   {
     if (!bitmap.test(idx))
@@ -57,8 +57,8 @@
   return first_bit;
 }
 
-bool isBitmapOverlapping(const bitset<MAX_FIELDS> &map1, const bitset<MAX_FIELDS> &map2)
+bool isBitmapOverlapping(const bitset<MAX_FIELDS> *map1, const bitset<MAX_FIELDS> *map2)
 {
-  bitset<MAX_FIELDS> tmp= map1 & map2;
+  bitset<MAX_FIELDS> tmp= *map1 & *map2;
   return (tmp.any());
 }

=== modified file 'drizzled/sql_bitmap.h'
--- drizzled/sql_bitmap.h	2009-04-17 02:52:53 +0000
+++ drizzled/sql_bitmap.h	2009-05-08 19:07:39 +0000
@@ -20,15 +20,191 @@
 #ifndef _SQL_BITMAP_H_
 #define _SQL_BITMAP_H_
 
-#include <drizzled/global.h>
+/*
+  Implementation of a bitmap type.
+  The idea with this is to be able to handle any constant number of bits but
+  also be able to use 32 or 64 bits bitmaps very efficiently
+*/
+
+/// TODO: OMG FIX THIS
+
+#include <mysys/my_bitmap.h>
 #include <drizzled/definitions.h>
 #include <drizzled/util/test.h>
 
 #include <bitset>
 
-#define BIT_NONE (~(uint32_t) 0)
+template <uint32_t default_width> class Bitmap
+{
+  MY_BITMAP map;
+  uint32_t buffer[(default_width+31)/32];
+public:
+  Bitmap() : map() { init(); }
+  Bitmap(const Bitmap& from) : map() { *this=from; }
+  explicit Bitmap(uint32_t prefix_to_set) : map(0) { init(prefix_to_set); }
+  void init() { bitmap_init(&map, buffer, default_width, 0); }
+  void init(uint32_t prefix_to_set) { init(); set_prefix(prefix_to_set); }
+  uint32_t length() const { return default_width; }
+  Bitmap& operator=(const Bitmap& map2)
+  {
+    init();
+    memcpy(buffer, map2.buffer, sizeof(buffer));
+    return *this;
+  }
+  void set_bit(uint32_t n) { bitmap_set_bit(&map, n); }
+  void clear_bit(uint32_t n) { bitmap_clear_bit(&map, n); }
+  void set_prefix(uint32_t n) { bitmap_set_prefix(&map, n); }
+  void set_all() { bitmap_set_all(&map); }
+  void clear_all() { bitmap_clear_all(&map); }
+  void intersect(Bitmap& map2) { bitmap_intersect(&map, &map2.map); }
+  void intersect(uint64_t map2buff)
+  {
+    MY_BITMAP map2;
+    bitmap_init(&map2, (uint32_t *)&map2buff, sizeof(uint64_t)*8, 0);
+    bitmap_intersect(&map, &map2);
+  }
+  /* Use highest bit for all bits above sizeof(uint64_t)*8. */
+  void intersect_extended(uint64_t map2buff)
+  {
+    intersect(map2buff);
+    if (map.n_bits > sizeof(uint64_t) * 8)
+      bitmap_set_above(&map, sizeof(uint64_t),
+                       test(map2buff & (1 << (sizeof(uint64_t) * 8 - 1))));
+  }
+  void subtract(Bitmap& map2) { bitmap_subtract(&map, &map2.map); }
+  void merge(Bitmap& map2) { bitmap_union(&map, &map2.map); }
+  bool is_set(uint32_t n) const { return bitmap_is_set(&map, n); }
+  bool is_set() const { return !bitmap_is_clear_all(&map); }
+  bool is_prefix(uint32_t n) const { return bitmap_is_prefix(&map, n); }
+  bool is_clear_all() const { return bitmap_is_clear_all(&map); }
+  bool is_set_all() const { return bitmap_is_set_all(&map); }
+  bool is_subset(const Bitmap& map2) const { return bitmap_is_subset(&map, &map2.map); }
+  bool operator==(const Bitmap& map2) const { return bitmap_cmp(&map, &map2.map); }
+  bool operator!=(const Bitmap& map2) const { return !bitmap_cmp(&map, &map2.map); }
+  Bitmap operator&=(uint32_t n)
+  {
+    if (bitmap_is_set(&map, n))
+    {
+      bitmap_clear_all(&map);
+      bitmap_set_bit(&map, n);
+    }
+    else
+      bitmap_clear_all(&map);
+    return *this;
+  }
+  Bitmap operator&=(const Bitmap& map2)
+  {
+    bitmap_intersect(&map, &map2.map);
+    return *this;
+  }
+  Bitmap operator&(uint32_t n)
+  {
+    Bitmap bm(*this);
+    bm&= n;
+    return bm;
+  }
+  Bitmap operator&(const Bitmap& map2)
+  {
+    Bitmap bm(*this);
+    bm&= map2;
+    return bm;
+  }
+  Bitmap operator|=(uint32_t n)
+  {
+    bitmap_set_bit(&map, n);
+    return *this;
+  }
+  Bitmap operator|=(const Bitmap& map2)
+  {
+    bitmap_union(&map, &map2.map);
+  }
+  Bitmap operator|(uint32_t n)
+  {
+    Bitmap bm(*this);
+    bm|= n;
+    return bm;
+  }
+  Bitmap operator|(const Bitmap& map2)
+  {
+    Bitmap bm(*this);
+    bm|= map2;
+    return bm;
+  }
+  Bitmap operator~()
+  {
+    Bitmap bm(*this);
+    bitmap_invert(&bm.map);
+    return bm;
+  }
+  char *print(char *buf) const
+  {
+    char *s=buf;
+    const unsigned char *e=(unsigned char *)buffer, *b=e+sizeof(buffer)-1;
+    while (!*b && b>e)
+      b--;
+    if ((*s=_dig_vec_upper[*b >> 4]) != '0')
+        s++;
+    *s++=_dig_vec_upper[*b & 15];
+    while (--b>=e)
+    {
+      *s++=_dig_vec_upper[*b >> 4];
+      *s++=_dig_vec_upper[*b & 15];
+    }
+    *s=0;
+    return buf;
+  }
+  uint64_t to_uint64_t() const
+  {
+    if (sizeof(buffer) >= 8)
+      return uint8korr(buffer);
+    assert(sizeof(buffer) >= 4);
+    return (uint64_t) uint4korr(buffer);
+  }
+};
+
+template <> class Bitmap<64>
+{
+  uint64_t map;
+public:
+  Bitmap<64>() : map(0) { }
+  explicit Bitmap<64>(uint32_t prefix_to_set) : map(0) { set_prefix(prefix_to_set); }
+  void init() { }
+  void init(uint32_t prefix_to_set) { set_prefix(prefix_to_set); }
+  uint32_t length() const { return 64; }
+  void set_bit(uint32_t n) { map|= ((uint64_t)1) << n; }
+  void clear_bit(uint32_t n) { map&= ~(((uint64_t)1) << n); }
+  void set_prefix(uint32_t n)
+  {
+    if (n >= length())
+      set_all();
+    else
+      map= (((uint64_t)1) << n)-1;
+  }
+  void set_all() { map=~(uint64_t)0; }
+  void clear_all() { map=(uint64_t)0; }
+  void intersect(Bitmap<64>& map2) { map&= map2.map; }
+  void intersect(uint64_t map2) { map&= map2; }
+  void intersect_extended(uint64_t map2) { map&= map2; }
+  void subtract(Bitmap<64>& map2) { map&= ~map2.map; }
+  void merge(Bitmap<64>& map2) { map|= map2.map; }
+  bool is_set(uint32_t n) const { return test(map & (((uint64_t)1) << n)); }
+  bool is_prefix(uint32_t n) const { return map == (((uint64_t)1) << n)-1; }
+  bool is_clear_all() const { return map == (uint64_t)0; }
+  bool is_set_all() const { return map == ~(uint64_t)0; }
+  bool is_subset(const Bitmap<64>& map2) const { return !(map & ~map2.map); }
+  bool is_overlapping(const Bitmap<64>& map2) const { return (map & map2.map)!= 0; }
+  bool operator==(const Bitmap<64>& map2) const { return map == map2.map; }
+  char *print(char *buf) const { int64_t2str(map,buf,16); return buf; }
+  uint64_t to_uint64_t() const { return map; }
+};
+
 
 typedef uint64_t table_map;          /* Used for table bits in join */
+#if MAX_INDEXES <= 64
+typedef Bitmap<64>  key_map;          /* Used for finding keys */
+#else
+typedef Bitmap<((MAX_INDEXES+7)/8*8)> key_map; /* Used for finding keys */
+#endif
 typedef uint32_t nesting_map;  /* Used for flags of nesting constructs */
 
 /*
@@ -38,6 +214,10 @@
 */
 typedef uint64_t nested_join_map; /* Needed by sql_select.h and table.h */
 
+/* useful constants */#
+extern const key_map key_map_empty;
+extern key_map key_map_full;          /* Should be threaded as const */
+
 /*
  * Finds the first bit that is not set and sets
  * it.
@@ -49,7 +229,7 @@
 /*
  * Returns the position of the first bit in the
  * given bitmap which is not set. If every bit is set
- * in the bitmap, return BIT_NONE.
+ * in the bitmap, return MY_BIT_NONE.
  *
  * @param the bitmap to work with
  */
@@ -62,6 +242,6 @@
  * @param the first bitmap to work with
  * @param the second bitmap to work with
  */
-bool isBitmapOverlapping(const std::bitset<MAX_FIELDS> &map1, const std::bitset<MAX_FIELDS> &map2);
+bool isBitmapOverlapping(const std::bitset<MAX_FIELDS> *map1, const std::bitset<MAX_FIELDS> *map2);
 
 #endif /* _SQL_BITMAP_H_ */

=== modified file 'drizzled/sql_delete.cc'
--- drizzled/sql_delete.cc	2009-04-29 07:16:04 +0000
+++ drizzled/sql_delete.cc	2009-05-08 19:07:39 +0000
@@ -152,8 +152,8 @@
   /* Update the table->file->stats.records number */
   table->file->info(HA_STATUS_VARIABLE | HA_STATUS_NO_LOCK);
 
-  table->covering_keys.reset();
-  table->quick_keys.reset();		// Can't use 'only index'
+  table->covering_keys.clear_all();
+  table->quick_keys.clear_all();		// Can't use 'only index'
   select=make_select(table, 0, 0, conds, 0, &error);
   if (error)
     goto err;
@@ -173,7 +173,7 @@
   }
 
   /* If running in safe sql mode, don't allow updates without keys */
-  if (table->quick_keys.none())
+  if (table->quick_keys.is_clear_all())
   {
     session->server_status|=SERVER_QUERY_NO_INDEX_USED;
     if (safe_update && !using_limit)
@@ -194,7 +194,7 @@
     SORT_FIELD  *sortorder;
     ha_rows examined_rows;
 
-    if ((!select || table->quick_keys.none()) && limit != HA_POS_ERROR)
+    if ((!select || table->quick_keys.is_clear_all()) && limit != HA_POS_ERROR)
       usable_index= get_index_for_order(table, (order_st*)(order->first), limit);
 
     if (usable_index == MAX_KEY)
@@ -504,7 +504,7 @@
       tbl->no_keyread=1;
       /* Don't use record cache */
       tbl->no_cache= 1;
-      tbl->covering_keys.reset();
+      tbl->covering_keys.clear_all();
       if (tbl->file->has_transactions())
 	transactional_tables= 1;
       else

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2009-04-28 07:29:32 +0000
+++ drizzled/sql_select.cc	2009-05-08 19:07:39 +0000
@@ -50,7 +50,6 @@
 
 #include <string>
 #include <bitset>
-#include <iostream>
 
 using namespace std;
 
@@ -800,7 +799,7 @@
 static void save_index_subquery_explain_info(JOIN_TAB *join_tab, Item* where)
 {
   join_tab->packed_info= TAB_INFO_HAVE_VALUE;
-  if (join_tab->table->covering_keys.test(join_tab->ref.key))
+  if (join_tab->table->covering_keys.is_set(join_tab->ref.key))
     join_tab->packed_info |= TAB_INFO_USING_INDEX;
   if (where)
     join_tab->packed_info |= TAB_INFO_USING_WHERE;
@@ -3446,10 +3445,10 @@
   {
     TableList *embedding= tables->embedding;
     stat_vector[i]=s;
-    s->keys.reset();
-    s->const_keys.reset();
-    s->checked_keys.reset();
-    s->needed_reg.reset();
+    s->keys.init();
+    s->const_keys.init();
+    s->checked_keys.init();
+    s->needed_reg.init();
     table_vector[i]=s->table=table=tables->table;
     table->pos_in_table_list= tables;
     error= table->file->info(HA_STATUS_VARIABLE | HA_STATUS_NO_LOCK);
@@ -3458,7 +3457,7 @@
         table->file->print_error(error, MYF(0));
         return(1);
     }
-    table->quick_keys.reset();
+    table->quick_keys.clear_all();
     table->reginfo.join_tab=s;
     table->reginfo.not_exists_optimize=0;
     memset(table->const_key_parts, 0,
@@ -3655,25 +3654,25 @@
 	{
 	  start_keyuse=keyuse;
 	  key=keyuse->key;
-	  s->keys.set(key);               // QQ: remove this ?
+	  s->keys.set_bit(key);               // QQ: remove this ?
 
 	  refs=0;
-          const_ref.reset();
-	  eq_part.reset();
+          const_ref.clear_all();
+	  eq_part.clear_all();
 	  do
 	  {
 	    if (keyuse->val->type() != Item::NULL_ITEM && !keyuse->optimize)
 	    {
 	      if (!((~found_const_table_map) & keyuse->used_tables))
-		const_ref.set(keyuse->keypart);
+		const_ref.set_bit(keyuse->keypart);
 	      else
 		refs|=keyuse->used_tables;
-	      eq_part.set(keyuse->keypart);
+	      eq_part.set_bit(keyuse->keypart);
 	    }
 	    keyuse++;
 	  } while (keyuse->table == table && keyuse->key == key);
 
-	  if (is_keymap_prefix(eq_part, table->key_info[key].key_parts) &&
+	  if (eq_part.is_prefix(table->key_info[key].key_parts) &&
               !table->pos_in_table_list->embedding)
 	  {
             if ((table->key_info[key].flags & (HA_NOSAME))
@@ -3684,7 +3683,7 @@
 	        int tmp;
 	        ref_changed = 1;
 	        s->type= JT_CONST;
-	        join->const_table_map|= table->map;
+	        join->const_table_map|=table->map;
 	        set_position(join,const_count++,s,start_keyuse);
 	        if (create_ref_for_key(join, s, start_keyuse,
 				       found_const_table_map))
@@ -3703,7 +3702,7 @@
 	        found_ref|= refs;      // Table is const if all refs are const
 	    }
             else if (const_ref == eq_part)
-              s->const_keys.set(key);
+              s->const_keys.set_bit(key);
           }
 	}
       }
@@ -3721,12 +3720,12 @@
       Field *field= sargables->field;
       JOIN_TAB *join_tab= field->table->reginfo.join_tab;
       key_map possible_keys= field->key_start;
-      possible_keys&= field->table->keys_in_use_for_query;
+      possible_keys.intersect(field->table->keys_in_use_for_query);
       bool is_const= 1;
       for (uint32_t j=0; j < sargables->num_values; j++)
         is_const&= sargables->arg_value[j]->const_item();
       if (is_const)
-        join_tab[0].const_keys|= possible_keys;
+        join_tab[0].const_keys.merge(possible_keys);
     }
   }
 
@@ -3763,7 +3762,7 @@
     */
     add_group_and_distinct_keys(join, s);
 
-    if (s->const_keys.any() &&
+    if (!s->const_keys.is_clear_all() &&
         !s->table->pos_in_table_list->embedding)
     {
       ha_rows records;
@@ -4045,9 +4044,9 @@
     else
     {
       JOIN_TAB *stat=field->table->reginfo.join_tab;
-      key_map possible_keys= field->key_start;
-      possible_keys&= field->table->keys_in_use_for_query;
-      stat[0].keys|= possible_keys;             // Add possible keys
+      key_map possible_keys=field->key_start;
+      possible_keys.intersect(field->table->keys_in_use_for_query);
+      stat[0].keys.merge(possible_keys);             // Add possible keys
 
       /*
 	Save the following cases:
@@ -4060,7 +4059,7 @@
          Field BETWEEN ...
          Field IN ...
       */
-      stat[0].key_dependent|= used_tables;
+      stat[0].key_dependent|=used_tables;
 
       bool is_const=1;
       for (uint32_t i=0; i<num_values; i++)
@@ -4069,7 +4068,7 @@
           break;
       }
       if (is_const)
-        stat[0].const_keys|= possible_keys;
+        stat[0].const_keys.merge(possible_keys);
       else if (!eq_func)
       {
         /*
@@ -4432,7 +4431,7 @@
   {
     for (uint32_t key= 0 ; key < form->sizeKeys() ; key++)
     {
-      if (!(form->keys_in_use_for_query.test(key)))
+      if (!(form->keys_in_use_for_query.is_set(key)))
 	continue;
 
       uint32_t key_parts= (uint32_t) form->key_info[key].key_parts;
@@ -4707,7 +4706,7 @@
       /* Save ptr to first use */
       if (!use->table->reginfo.join_tab->keyuse)
 	use->table->reginfo.join_tab->keyuse=save_pos;
-      use->table->reginfo.join_tab->checked_keys.set(use->key);
+      use->table->reginfo.join_tab->checked_keys.set_bit(use->key);
       save_pos++;
     }
     i=(uint32_t) (save_pos-(KEYUSE*) keyuse->buffer);
@@ -4809,14 +4808,14 @@
 
   /* Intersect the keys of all group fields. */
   cur_item= indexed_fields_it++;
-  possible_keys|= cur_item->field->part_of_key;
+  possible_keys.merge(cur_item->field->part_of_key);
   while ((cur_item= indexed_fields_it++))
   {
-    possible_keys&= cur_item->field->part_of_key;
+    possible_keys.intersect(cur_item->field->part_of_key);
   }
 
-  if (possible_keys.any())
-    join_tab->const_keys|= possible_keys;
+  if (!possible_keys.is_clear_all())
+    join_tab->const_keys.merge(possible_keys);
 }
 
 
@@ -5056,7 +5055,7 @@
              ...
         */
         if (try_sj_inside_out &&
-            table->covering_keys.test(key) &&
+            table->covering_keys.is_set(key) &&
             (handled_sj_equalities | bound_sj_equalities) ==     // (1)
             PREV_BITS(uint64_t, s->emb_sj_nest->sj_in_exprs)) // (1)
         {
@@ -5128,7 +5127,7 @@
                 quick_cond is equivalent to ref_const_cond (if it was an
                 empty interval we wouldn't have got here).
               */
-              if (table->quick_keys.test(key))
+              if (table->quick_keys.is_set(key))
                 records= (double) table->quick_rows[key];
               else
               {
@@ -5158,7 +5157,7 @@
                 can make an adjustment is a special case of the criteria used
                 in ReuseRangeEstimateForRef-3.
               */
-              if (table->quick_keys.test(key) &&
+              if (table->quick_keys.is_set(key) &&
                   const_part & (1 << table->quick_key_parts[key]) &&
                   table->quick_n_ranges[key] == 1 &&
                   records > (double) table->quick_rows[key])
@@ -5169,7 +5168,7 @@
             /* Limit the number of matched rows */
             tmp= records;
             set_if_smaller(tmp, (double) session->variables.max_seeks_for_key);
-            if (table->covering_keys.test(key))
+            if (table->covering_keys.is_set(key))
             {
               /* we can use only index tree */
               tmp= record_count * table->file->index_only_read_time(key, tmp);
@@ -5229,7 +5228,7 @@
 
               (C3) "range optimizer used (have ref_or_null?2:1) intervals"
             */
-            if (table->quick_keys.test(key) && !found_ref &&          //(C1)
+            if (table->quick_keys.is_set(key) && !found_ref &&          //(C1)
                 table->quick_key_parts[key] == max_key_part &&          //(C2)
                 table->quick_n_ranges[key] == 1+((ref_or_null_part)?1:0)) //(C3)
             {
@@ -5256,7 +5255,7 @@
                   cheaper in some cases ?
                   TODO: figure this out and adjust the plan choice if needed.
                 */
-                if (!found_ref && table->quick_keys.test(key) &&    // (1)
+                if (!found_ref && table->quick_keys.is_set(key) &&    // (1)
                     table->quick_key_parts[key] > max_key_part &&     // (2)
                     records < (double)table->quick_rows[key])         // (3)
                   records= (double)table->quick_rows[key];
@@ -5321,7 +5320,7 @@
                 optimizer is the same as in ReuseRangeEstimateForRef-3,
                 applied to first table->quick_key_parts[key] key parts.
               */
-              if (table->quick_keys.test(key) &&
+              if (table->quick_keys.is_set(key) &&
                   table->quick_key_parts[key] <= max_key_part &&
                   const_part & (1 << table->quick_key_parts[key]) &&
                   table->quick_n_ranges[key] == 1 + ((ref_or_null_part &
@@ -5334,7 +5333,7 @@
 
             /* Limit the number of matched rows */
             set_if_smaller(tmp, (double) session->variables.max_seeks_for_key);
-            if (table->covering_keys.test(key))
+            if (table->covering_keys.is_set(key))
             {
               /* we can use only index tree */
               tmp= record_count * table->file->index_only_read_time(key, tmp);
@@ -5400,7 +5399,7 @@
       !(s->quick && best_key && s->quick->index == best_key->key &&      // (2)
         best_max_key_part >= s->table->quick_key_parts[best_key->key]) &&// (2)
       !((s->table->file->ha_table_flags() & HA_TABLE_SCAN_ON_INDEX) &&   // (3)
-        ! s->table->covering_keys.none() && best_key && !s->quick) &&// (3)
+        ! s->table->covering_keys.is_clear_all() && best_key && !s->quick) &&// (3)
       !(s->table->force_index && best_key && !s->quick))                 // (4)
   {                                             // Check full join
     ha_rows rnd_records= s->found_records;
@@ -6406,7 +6405,7 @@
 
     if (j->type == JT_SYSTEM)
       continue;
-    if (j->keys.none() || !(keyuse= join->best_positions[tablenr].key))
+    if (j->keys.is_clear_all() || !(keyuse= join->best_positions[tablenr].key))
     {
       j->type=JT_ALL;
       if (tablenr != join->const_tables)
@@ -6661,7 +6660,8 @@
   join_tab->select_cond=0;
   join_tab->quick=0;
   join_tab->type= JT_ALL;			/* Map through all records */
-  join_tab->keys.set();                     /* test everything in quick */
+  join_tab->keys.init();
+  join_tab->keys.set_all();                     /* test everything in quick */
   join_tab->info=0;
   join_tab->on_expr_ref=0;
   join_tab->last_inner= 0;
@@ -7082,12 +7082,12 @@
 	{
 	  /* Use quick key read if it's a constant and it's not used
 	     with key reading */
-	  if (tab->needed_reg.none() && tab->type != JT_EQ_REF
+	  if (tab->needed_reg.is_clear_all() && tab->type != JT_EQ_REF
 	      && (tab->type != JT_REF || (uint32_t) tab->ref.key == tab->quick->index))
 	  {
 	    sel->quick=tab->quick;		// Use value from get_quick_...
-	    sel->quick_keys.reset();
-	    sel->needed_reg.reset();
+	    sel->quick_keys.clear_all();
+	    sel->needed_reg.clear_all();
 	  }
 	  else
 	  {
@@ -7098,13 +7098,13 @@
 	uint32_t ref_key=(uint32_t) sel->head->reginfo.join_tab->ref.key+1;
 	if (i == join->const_tables && ref_key)
 	{
-	  if (tab->const_keys.any() &&
+	  if (!tab->const_keys.is_clear_all() &&
               tab->table->reginfo.impossible_range)
 	    return(1);
 	}
 	else if (tab->type == JT_ALL && ! use_quick_range)
 	{
-	  if (tab->const_keys.any() &&
+	  if (!tab->const_keys.is_clear_all() &&
 	      tab->table->reginfo.impossible_range)
 	    return(1);				// Impossible range
 	  /*
@@ -7114,8 +7114,8 @@
 	    the index if we are using limit and this is the first table
 	  */
 
-	  if ((cond && (!((tab->const_keys & tab->keys) == tab->keys) && i > 0)) ||
-	      (!tab->const_keys.none() && (i == join->const_tables) && (join->unit->select_limit_cnt < join->best_positions[i].records_read) && ((join->select_options & OPTION_FOUND_ROWS) == false)))
+	  if ((cond && (!tab->keys.is_subset(tab->const_keys) && i > 0)) ||
+	      (!tab->const_keys.is_clear_all() && (i == join->const_tables) && (join->unit->select_limit_cnt < join->best_positions[i].records_read) && ((join->select_options & OPTION_FOUND_ROWS) == false)))
 	  {
 	    /* Join with outer join condition */
 	    COND *orig_cond=sel->cond;
@@ -7164,15 +7164,15 @@
 	  else
 	  {
 	    sel->needed_reg=tab->needed_reg;
-	    sel->quick_keys.reset();
+	    sel->quick_keys.clear_all();
 	  }
-	  if (!((tab->checked_keys & sel->quick_keys) == sel->quick_keys) ||
-              !((tab->checked_keys & sel->needed_reg) == sel->needed_reg))
+	  if (!sel->quick_keys.is_subset(tab->checked_keys) ||
+              !sel->needed_reg.is_subset(tab->checked_keys))
 	  {
-	    tab->keys= sel->quick_keys;
-            tab->keys|= sel->needed_reg;
-	    tab->use_quick= (!sel->needed_reg.none() &&
-			     (select->quick_keys.none() ||
+	    tab->keys=sel->quick_keys;
+            tab->keys.merge(sel->needed_reg);
+	    tab->use_quick= (!sel->needed_reg.is_clear_all() &&
+			     (select->quick_keys.is_clear_all() ||
 			      (select->quick &&
 			       (select->quick->records >= 100L)))) ?
 	      2 : 1;
@@ -7359,7 +7359,7 @@
       Item_field *item_field= (Item_field*)item;
       if (item_field->field->table != tbl)
         return true;
-      return item_field->field->part_of_key.test(keyno);
+      return item_field->field->part_of_key.is_set(keyno);
     }
   case Item::REF_ITEM:
     return uses_index_fields_only(item->real_item(), tbl, keyno,
@@ -7682,7 +7682,7 @@
       table->status=STATUS_NO_RECORD;
       tab->read_first_record= join_read_const;
       tab->read_record.read_record= join_no_more_records;
-      if (table->covering_keys.test(tab->ref.key) &&
+      if (table->covering_keys.is_set(tab->ref.key) &&
           !table->no_keyread)
       {
         table->key_read=1;
@@ -7700,7 +7700,7 @@
       tab->quick=0;
       tab->read_first_record= join_read_key;
       tab->read_record.read_record= join_no_more_records;
-      if (table->covering_keys.test(tab->ref.key) &&
+      if (table->covering_keys.is_set(tab->ref.key) &&
 	  !table->no_keyread)
       {
 	table->key_read=1;
@@ -7719,7 +7719,7 @@
       }
       delete tab->quick;
       tab->quick=0;
-      if (table->covering_keys.test(tab->ref.key) &&
+      if (table->covering_keys.is_set(tab->ref.key) &&
 	  !table->no_keyread)
       {
 	table->key_read=1;
@@ -7801,12 +7801,12 @@
 	{
 	  if (tab->select && tab->select->quick &&
               tab->select->quick->index != MAX_KEY && //not index_merge
-	      table->covering_keys.test(tab->select->quick->index))
+	      table->covering_keys.is_set(tab->select->quick->index))
 	  {
 	    table->key_read=1;
 	    table->file->extra(HA_EXTRA_KEYREAD);
 	  }
-	  else if (!table->covering_keys.none() &&
+	  else if (!table->covering_keys.is_clear_all() &&
 		   !(tab->select && tab->select->quick))
 	  {					// Only read index tree
             if (!tab->insideout_match_tab)
@@ -9411,20 +9411,20 @@
         Field *field= item_field->field;
         JOIN_TAB *stat= field->table->reginfo.join_tab;
         key_map possible_keys= field->key_start;
-        possible_keys&= field->table->keys_in_use_for_query;
-        stat[0].const_keys|= possible_keys;
+        possible_keys.intersect(field->table->keys_in_use_for_query);
+        stat[0].const_keys.merge(possible_keys);
 
         /*
           For each field in the multiple equality (for which we know that it
           is a constant) we have to find its corresponding key part, and set
           that key part in const_key_parts.
         */
-        if (possible_keys.any())
+        if (!possible_keys.is_clear_all())
         {
           Table *field_tab= field->table;
           KEYUSE *use;
           for (use= stat->keyuse; use && use->table == field_tab; use++)
-            if (possible_keys.test(use->key) &&
+            if (possible_keys.is_set(use->key) &&
                 field_tab->key_info[use->key].key_part[use->keypart].field ==
                 field)
               field_tab->const_key_parts[use->key]|= use->keypart_map;
@@ -11313,7 +11313,7 @@
   }
   else
   {
-    if (!table->key_read && table->covering_keys.test(tab->ref.key) &&
+    if (!table->key_read && table->covering_keys.is_set(tab->ref.key) &&
 	!table->no_keyread &&
         (int) table->reginfo.lock_type <= (int) TL_READ_HIGH_PRIORITY)
     {
@@ -11698,7 +11698,7 @@
 {
   int error;
   Table *table=tab->table;
-  if (!table->key_read && table->covering_keys.test(tab->index) &&
+  if (!table->key_read && table->covering_keys.is_set(tab->index) &&
       !table->no_keyread)
   {
     table->key_read=1;
@@ -11774,7 +11774,7 @@
 {
   Table *table=tab->table;
   int error;
-  if (!table->key_read && table->covering_keys.test(tab->index) &&
+  if (!table->key_read && table->covering_keys.is_set(tab->index) &&
       !table->no_keyread)
   {
     table->key_read=1;
@@ -12679,7 +12679,7 @@
 
   for (nr= 0 ; nr < table->s->keys ; nr++)
   {
-    if (usable_keys->test(nr) &&
+    if (usable_keys->is_set(nr) &&
 	table->key_info[nr].key_length < min_length &&
 	table->key_info[nr].key_parts >= ref_key_parts &&
 	is_subkey(table->key_info[nr].key_part, ref_key_part,
@@ -12873,11 +12873,11 @@
     Item *item= (*tmp_order->item)->real_item();
     if (item->type() != Item::FIELD_ITEM)
     {
-      usable_keys.reset();
+      usable_keys.clear_all();
       return(0);
     }
-    usable_keys&= ((Item_field*) item)->field->part_of_sortkey;
-    if (usable_keys.none())
+    usable_keys.intersect(((Item_field*) item)->field->part_of_sortkey);
+    if (usable_keys.is_clear_all())
       return(0);					// No usable keys
   }
 
@@ -12913,7 +12913,7 @@
     /*
       We come here when there is a REF key.
     */
-    if (! usable_keys.test(ref_key))
+    if (!usable_keys.is_set(ref_key))
     {
       /*
 	We come here when ref_key is not among usable_keys
@@ -12923,8 +12923,8 @@
 	If using index only read, only consider other possible index only
 	keys
       */
-      if (table->covering_keys.test(ref_key))
-	usable_keys&= table->covering_keys;
+      if (table->covering_keys.is_set(ref_key))
+	usable_keys.intersect(table->covering_keys);
       if (tab->pre_idx_push_select_cond)
         tab->select_cond= tab->select->cond= tab->pre_idx_push_select_cond;
       if ((new_ref_key= test_if_subkey(order, table, ref_key, ref_key_parts,
@@ -12960,8 +12960,8 @@
             parameres are set correctly by the range optimizer.
            */
           key_map new_ref_key_map;
-          new_ref_key_map.reset();  // Force the creation of quick select
-          new_ref_key_map.set(new_ref_key); // only for new_ref_key.
+          new_ref_key_map.clear_all();  // Force the creation of quick select
+          new_ref_key_map.set_bit(new_ref_key); // only for new_ref_key.
 
           if (select->test_quick_select(tab->join->session, new_ref_key_map, 0,
                                         (tab->join->select_options &
@@ -12976,7 +12976,7 @@
       }
     }
     /* Check if we get the rows in requested sorted order by using the key */
-    if (usable_keys.test(ref_key) &&
+    if (usable_keys.is_set(ref_key) &&
         (order_direction= test_if_order_by_key(order,table,ref_key,
 					       &used_key_parts)))
       goto check_reverse_order;
@@ -13016,7 +13016,7 @@
       if (tab->type == JT_ALL && tab->join->tables > tab->join->const_tables + 1)
         return(0);
       keys= *table->file->keys_to_use_for_scanning();
-      keys|= table->covering_keys;
+      keys.merge(table->covering_keys);
 
       /*
 	We are adding here also the index specified in FORCE INDEX clause,
@@ -13024,9 +13024,9 @@
         This is to allow users to use index in order_st BY.
       */
       if (table->force_index)
-	keys|= (group ? table->keys_in_use_for_group_by :
+	keys.merge(group ? table->keys_in_use_for_group_by :
                            table->keys_in_use_for_order_by);
-      keys&= usable_keys;
+      keys.intersect(usable_keys);
     }
     else
       keys= usable_keys;
@@ -13038,10 +13038,10 @@
     for (nr=0; nr < table->s->keys ; nr++)
     {
       int direction;
-      if (keys.test(nr) &&
+      if (keys.is_set(nr) &&
           (direction= test_if_order_by_key(order, table, nr, &used_key_parts)))
       {
-        bool is_covering= table->covering_keys.test(nr) || (nr == table->s->primary_key && table->file->primary_key_is_clustered());
+        bool is_covering= table->covering_keys.is_set(nr) || (nr == table->s->primary_key && table->file->primary_key_is_clustered());
 
         /*
           Don't use an index scan with order_st BY without limit.
@@ -13124,7 +13124,7 @@
             ha_rows quick_records= table_records;
             if (is_best_covering && !is_covering)
               continue;
-            if (table->quick_keys.test(nr))
+            if (table->quick_keys.is_set(nr))
               quick_records= table->quick_rows[nr];
             if (best_key < 0 ||
                 (select_limit <= cmin(quick_records,best_records) ?
@@ -13144,11 +13144,11 @@
     if (best_key >= 0)
     {
       bool quick_created= false;
-      if (table->quick_keys.test(best_key) && best_key != ref_key)
+      if (table->quick_keys.is_set(best_key) && best_key != ref_key)
       {
         key_map test_map;
-        test_map.reset();       // Force the creation of quick select
-        test_map.set(best_key); // only best_key.
+        test_map.clear_all();       // Force the creation of quick select
+        test_map.set_bit(best_key); // only best_key.
         quick_created=
           select->test_quick_select(join->session, test_map, 0,
                                     join->select_options & OPTION_FOUND_ROWS ?
@@ -13169,7 +13169,7 @@
             delete select->quick;
             select->quick= 0;
           }
-          if (table->covering_keys.test(best_key))
+          if (table->covering_keys.is_set(best_key))
           {
             table->key_read=1;
             table->file->extra(HA_EXTRA_KEYREAD);
@@ -15839,12 +15839,12 @@
 					  strlen(join_type_str[tab->type]),
 					  cs));
       /* Build "possible_keys" value and add it to item_list */
-      if (tab->keys.any())
+      if (!tab->keys.is_clear_all())
       {
         uint32_t j;
         for (j=0 ; j < table->s->keys ; j++)
         {
-          if (tab->keys.test(j))
+          if (tab->keys.is_set(j))
           {
             if (tmp1.length())
               tmp1.append(',');
@@ -15968,7 +15968,7 @@
       /* Build "Extra" field and add it to item_list. */
       bool key_read=table->key_read;
       if ((tab->type == JT_NEXT || tab->type == JT_CONST) &&
-          table->covering_keys.test(tab->index))
+          table->covering_keys.is_set(tab->index))
 	key_read=1;
       if (quick_type == QUICK_SELECT_I::QS_TYPE_ROR_INTERSECT &&
           !((QUICK_ROR_INTERSECT_SELECT*)tab->select->quick)->need_to_fetch_row)
@@ -16017,27 +16017,11 @@
 	{
 	  if (tab->use_quick == 2)
 	  {
-            /*
-             * To print out the bitset in tab->keys, we go through
-             * it 32 bits at a time. We need to do this to ensure
-             * that the to_ulong() method will not throw an
-             * out_of_range exception at runtime which would happen
-             * if the bitset we were working with was larger than 64
-             * bits on a 64-bit platform (for example).
-             */
-            stringstream s, w;
-            string str;
-            w << tab->keys;
-            w >> str;
-            for (uint32_t pos= 0; pos < tab->keys.size(); pos+= 32)
-            {
-              bitset<32> tmp(str, pos, 32);
-              if (tmp.any())
-                s << uppercase << hex << tmp.to_ulong();
-            }
+            /* 4 bits per 1 hex digit + terminating '\0' */
+            char buf[MAX_KEY / 4 + 1];
             extra.append(STRING_WITH_LEN("; Range checked for each "
                                          "record (index map: 0x"));
-            extra.append(s.str().c_str());
+            extra.append(tab->keys.print(buf));
             extra.append(')');
 	  }
 	  else if (tab->select->cond)

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-05-04 21:54:14 +0000
+++ drizzled/sql_table.cc	2009-05-08 19:07:39 +0000
@@ -1127,6 +1127,7 @@
             null_fields--;
 	  sql_field->flags=		dup_field->flags;
           sql_field->interval=          dup_field->interval;
+          sql_field->is_stored=      dup_field->is_stored;
 	  it2.remove();			// Remove first (create) definition
 	  select_field_pos--;
 	  break;
@@ -1158,6 +1159,23 @@
     sql_field->offset= record_offset;
     if (MTYP_TYPENR(sql_field->unireg_check) == Field::NEXT_NUMBER)
       auto_increment++;
+    /*
+          For now skip fields that are not physically stored in the database
+          (virtual fields) and update their offset later
+          (see the next loop).
+        */
+    if (sql_field->is_stored)
+      record_offset+= sql_field->pack_length;
+  }
+  /* Update virtual fields' offset */
+  it.rewind();
+  while ((sql_field=it++))
+  {
+    if (not sql_field->is_stored)
+    {
+      sql_field->offset= record_offset;
+      record_offset+= sql_field->pack_length;
+    }
   }
   if (timestamps_with_niladic > 1)
   {
@@ -1395,6 +1413,12 @@
 	    return(true);
 	  }
 	}
+        if (not sql_field->is_stored)
+        {
+          /* Key fields must always be physically stored. */
+          my_error(ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN, MYF(0));
+          return(true);
+        }
 	if (!(sql_field->flags & NOT_NULL_FLAG))
 	{
 	  if (key->type == Key::PRIMARY)
@@ -3971,6 +3995,13 @@
     if (def)
     {						// Field is changed
       def->field=field;
+      if (field->is_stored != def->is_stored)
+      {
+        my_error(ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN,
+                 MYF(0),
+                 "Changing the STORED status");
+        goto err;
+      }
       if (!def->after)
       {
 	new_create_list.push_back(def);

=== modified file 'drizzled/sql_update.cc'
--- drizzled/sql_update.cc	2009-05-04 21:06:03 +0000
+++ drizzled/sql_update.cc	2009-05-08 19:07:39 +0000
@@ -104,8 +104,8 @@
   table->mark_columns_used_by_index_no_reset(keynr, &unique_map);
 
   /* Subtract read_set and write_set. */
-  unique_map&= table->read_set->flip();
-  unique_map&= table->write_set->flip();
+  unique_map &= table->read_set->flip();
+  unique_map &= table->write_set->flip();
   table->read_set->flip();
   table->write_set->flip();
 
@@ -121,6 +121,8 @@
   table->file->position(table->record[0]);
   /* Add all fields used by unique index to read_set. */
   *(table->read_set) |= unique_map;
+  /* Tell the engine about the new set. */
+  table->file->column_bitmaps_signal();
   /* Read record that is identified by table->file->ref. */
   (void) table->file->rnd_pos(table->record[1], table->file->ref);
   /* Copy the newly read columns into the new record. */
@@ -199,7 +201,7 @@
 
   /* Calculate "table->covering_keys" based on the WHERE */
   table->covering_keys= table->s->keys_in_use;
-  table->quick_keys.reset();
+  table->quick_keys.clear_all();
 
   if (mysql_prepare_update(session, table_list, &conds, order_num, order))
     goto abort;
@@ -253,7 +255,7 @@
        table->timestamp_field_type == TIMESTAMP_AUTO_SET_ON_BOTH))
     *(table->read_set) |= *(table->write_set);
   // Don't count on usage of 'only index' when calculating which key to use
-  table->covering_keys.reset();
+  table->covering_keys.clear_all();
 
   /* Update the table->file->stats.records number */
   table->file->info(HA_STATUS_VARIABLE | HA_STATUS_NO_LOCK);
@@ -276,7 +278,7 @@
       need_sort= false;
   }
   /* If running in safe sql mode, don't allow updates without keys */
-  if (table->quick_keys.none())
+  if (table->quick_keys.is_clear_all())
   {
     session->server_status|=SERVER_QUERY_NO_INDEX_USED;
     if (safe_update && !using_limit)
@@ -313,7 +315,7 @@
       We can't update table directly;  We must first search after all
       matching rows before updating the table!
     */
-    if (used_index < MAX_KEY && old_covering_keys.test(used_index))
+    if (used_index < MAX_KEY && old_covering_keys.is_set(used_index))
     {
       table->key_read=1;
       table->mark_columns_used_by_index(used_index);
@@ -1045,7 +1047,7 @@
       update_tables.push_back(tl);
       tl->shared= table_count++;
       table->no_keyread=1;
-      table->covering_keys.reset();
+      table->covering_keys.clear_all();
       table->pos_in_table_list= tl;
     }
   }

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-05-04 22:41:24 +0000
+++ drizzled/table.cc	2009-05-08 19:07:39 +0000
@@ -530,8 +530,8 @@
     share->keynames.type_lengths[keynr]= indx.name().length();
   }
 
-  share->keys_for_keyread.reset();
-  set_prefix(share->keys_in_use, share->keys);
+  share->keys_for_keyread.init(0);
+  share->keys_in_use.init(share->keys);
 
   if(table_options.has_connect_string())
   {
@@ -556,6 +556,7 @@
 
   share->fields= table.field_size();
   share->vfields= 0;
+  share->stored_fields= share->fields;
 
   share->field= (Field**) alloc_root(&share->mem_root,
 				     ((share->fields+1) * sizeof(Field*)));
@@ -855,6 +856,8 @@
     }
 
     enum_field_types field_type;
+    bool field_is_stored= true;
+
 
     field_type= proto_field_type_to_drizzle_type(pfield.type());
 
@@ -963,6 +966,7 @@
 
     f->field_index= fieldnr;
     f->comment= comment;
+    f->is_stored= field_is_stored;
     if(!default_value
        && !(f->unireg_check==Field::NEXT_NUMBER)
        && (f->flags & NOT_NULL_FLAG)
@@ -978,6 +982,11 @@
     if (use_hash) /* supposedly this never fails... but comments lie */
       (void) my_hash_insert(&share->name_hash,
 			    (unsigned char*)&(share->field[fieldnr]));
+
+    if(!f->is_stored)
+    {
+      share->stored_fields--;
+    }
   }
 
   keyinfo= share->key_info;
@@ -1088,18 +1097,18 @@
                            (keyinfo->key_parts == 1)) ?
                            UNIQUE_KEY_FLAG : MULTIPLE_KEY_FLAG);
         if (i == 0)
-          field->key_start.set(key);
+          field->key_start.set_bit(key);
         if (field->key_length() == key_part->length &&
             !(field->flags & BLOB_FLAG))
         {
           if (handler_file->index_flags(key, i, 0) & HA_KEYREAD_ONLY)
           {
-            share->keys_for_keyread.set(key);
-            field->part_of_key.set(key);
-            field->part_of_key_not_clustered.set(key);
+            share->keys_for_keyread.set_bit(key);
+            field->part_of_key.set_bit(key);
+            field->part_of_key_not_clustered.set_bit(key);
           }
           if (handler_file->index_flags(key, i, 1) & HA_READ_ORDER)
-            field->part_of_sortkey.set(key);
+            field->part_of_sortkey.set_bit(key);
         }
         if (!(key_part->key_part_flag & HA_REVERSE_SORT) &&
             usable_parts == i)
@@ -1115,7 +1124,7 @@
           if (ha_option & HA_PRIMARY_KEY_IN_READ_INDEX)
           {
             field->part_of_key= share->keys_in_use;
-            if (field->part_of_sortkey.test(key))
+            if (field->part_of_sortkey.is_set(key))
               field->part_of_sortkey= share->keys_in_use;
           }
         }
@@ -1138,7 +1147,7 @@
         set_if_bigger(share->max_unique_length,keyinfo->key_length);
     }
     if (primary_key < MAX_KEY &&
-	(share->keys_in_use.test(primary_key)))
+	(share->keys_in_use.is_set(primary_key)))
     {
       share->primary_key= primary_key;
       /*
@@ -1198,6 +1207,13 @@
   }
 
   share->db_low_byte_first= handler_file->low_byte_first();
+  share->column_bitmap_size= bitmap_buffer_size(share->fields);
+
+  my_bitmap_map *bitmaps;
+
+  if (!(bitmaps= (my_bitmap_map*) alloc_root(&share->mem_root,
+                                             share->column_bitmap_size)))
+    goto err;
   share->all_set.set();
 
   if(handler_file)
@@ -1342,9 +1358,9 @@
 
   if (!(outparam->alias= strdup(alias)))
     goto err;
-  outparam->quick_keys.reset();
-  outparam->covering_keys.reset();
-  outparam->keys_in_use_for_query.reset();
+  outparam->quick_keys.init();
+  outparam->covering_keys.init();
+  outparam->keys_in_use_for_query.init();
 
   /* Allocate handler */
   outparam->file= 0;
@@ -1528,6 +1544,7 @@
   memset(bitmaps, 0, bitmap_size*3);
 #endif
 
+  outparam->no_replicate= outparam->file;
   session->status_var.opened_tables++;
 
   return (0);
@@ -2629,10 +2646,13 @@
 
 void Table::prepare_for_position()
 {
+
   if ((file->ha_table_flags() & HA_PRIMARY_KEY_IN_READ_INDEX) &&
       s->primary_key < MAX_KEY)
   {
     mark_columns_used_by_index_no_reset(s->primary_key, read_set);
+    /* signal change */
+    file->column_bitmaps_signal();
   }
   return;
 }
@@ -2677,6 +2697,8 @@
   key_read= 0;
   (void) file->extra(HA_EXTRA_NO_KEYREAD);
   default_column_bitmaps();
+  file->column_bitmaps_signal();
+  return;
 }
 
 
@@ -2714,6 +2736,7 @@
   write_set->set(found_next_number_field->field_index);
   if (s->next_number_keypart)
     mark_columns_used_by_index_no_reset(s->next_number_index, read_set);
+  file->column_bitmaps_signal();
 }
 
 
@@ -2745,6 +2768,7 @@
       if ((*reg_field)->flags & PART_KEY_FLAG)
         read_set->set((*reg_field)->field_index);
     }
+    file->column_bitmaps_signal();
   }
 
   {
@@ -2757,7 +2781,10 @@
     if (s->primary_key == MAX_KEY)
       file->use_hidden_primary_key();
     else
+    {
       mark_columns_used_by_index_no_reset(s->primary_key, read_set);
+      file->column_bitmaps_signal();
+    }
   }
 }
 
@@ -2789,9 +2816,10 @@
     for (reg_field= field ; *reg_field ; reg_field++)
     {
       /* Merge keys is all keys that had a column refered to in the query */
-      if (is_overlapping(merge_keys, (*reg_field)->part_of_key))
+      if (merge_keys.is_overlapping((*reg_field)->part_of_key))
         read_set->set((*reg_field)->field_index);
     }
+    file->column_bitmaps_signal();
   }
 
   {
@@ -2804,7 +2832,10 @@
     if (s->primary_key == MAX_KEY)
       file->use_hidden_primary_key();
     else
+    {
       mark_columns_used_by_index_no_reset(s->primary_key, read_set);
+      file->column_bitmaps_signal();
+    }
   }
   return;
 }
@@ -2944,9 +2975,9 @@
     /* initialize temporary variables used to collect hints of each kind */
     for (type= INDEX_HINT_IGNORE; type <= INDEX_HINT_FORCE; type++)
     {
-      index_join[type].reset();
-      index_order[type].reset();
-      index_group[type].reset();
+      index_join[type].clear_all();
+      index_order[type].clear_all();
+      index_group[type].clear_all();
     }
 
     /* iterate over the hints list */
@@ -2959,17 +2990,17 @@
       {
         if (hint->clause & INDEX_HINT_MASK_JOIN)
         {
-          index_join[hint->type].reset();
+          index_join[hint->type].clear_all();
           have_empty_use_join= true;
         }
         if (hint->clause & INDEX_HINT_MASK_ORDER)
         {
-          index_order[hint->type].reset();
+          index_order[hint->type].clear_all();
           have_empty_use_order= true;
         }
         if (hint->clause & INDEX_HINT_MASK_GROUP)
         {
-          index_group[hint->type].reset();
+          index_group[hint->type].clear_all();
           have_empty_use_group= true;
         }
         continue;
@@ -2991,20 +3022,20 @@
 
       /* add to the appropriate clause mask */
       if (hint->clause & INDEX_HINT_MASK_JOIN)
-        index_join[hint->type].set(pos);
+        index_join[hint->type].set_bit (pos);
       if (hint->clause & INDEX_HINT_MASK_ORDER)
-        index_order[hint->type].set(pos);
+        index_order[hint->type].set_bit (pos);
       if (hint->clause & INDEX_HINT_MASK_GROUP)
-        index_group[hint->type].set(pos);
+        index_group[hint->type].set_bit (pos);
     }
 
     /* cannot mix USE INDEX and FORCE INDEX */
-    if ((index_join[INDEX_HINT_FORCE].any() ||
-         index_order[INDEX_HINT_FORCE].any() ||
-         index_group[INDEX_HINT_FORCE].any()) &&
-        (index_join[INDEX_HINT_USE].any() ||  have_empty_use_join ||
-         index_order[INDEX_HINT_USE].any() || have_empty_use_order ||
-         index_group[INDEX_HINT_USE].any() || have_empty_use_group))
+    if ((!index_join[INDEX_HINT_FORCE].is_clear_all() ||
+         !index_order[INDEX_HINT_FORCE].is_clear_all() ||
+         !index_group[INDEX_HINT_FORCE].is_clear_all()) &&
+        (!index_join[INDEX_HINT_USE].is_clear_all() ||  have_empty_use_join ||
+         !index_order[INDEX_HINT_USE].is_clear_all() || have_empty_use_order ||
+         !index_group[INDEX_HINT_USE].is_clear_all() || have_empty_use_group))
     {
       my_error(ER_WRONG_USAGE, MYF(0), index_hint_type_name[INDEX_HINT_USE],
                index_hint_type_name[INDEX_HINT_FORCE]);
@@ -3012,32 +3043,32 @@
     }
 
     /* process FORCE INDEX as USE INDEX with a flag */
-    if (index_join[INDEX_HINT_FORCE].any() ||
-        index_order[INDEX_HINT_FORCE].any() ||
-        index_group[INDEX_HINT_FORCE].any())
+    if (!index_join[INDEX_HINT_FORCE].is_clear_all() ||
+        !index_order[INDEX_HINT_FORCE].is_clear_all() ||
+        !index_group[INDEX_HINT_FORCE].is_clear_all())
     {
       tbl->force_index= true;
-      index_join[INDEX_HINT_USE]|= index_join[INDEX_HINT_FORCE];
-      index_order[INDEX_HINT_USE]|= index_order[INDEX_HINT_FORCE];
-      index_group[INDEX_HINT_USE]|= index_group[INDEX_HINT_FORCE];
+      index_join[INDEX_HINT_USE].merge(index_join[INDEX_HINT_FORCE]);
+      index_order[INDEX_HINT_USE].merge(index_order[INDEX_HINT_FORCE]);
+      index_group[INDEX_HINT_USE].merge(index_group[INDEX_HINT_FORCE]);
     }
 
     /* apply USE INDEX */
-    if (index_join[INDEX_HINT_USE].any() || have_empty_use_join)
-      tbl->keys_in_use_for_query&= index_join[INDEX_HINT_USE];
-    if (index_order[INDEX_HINT_USE].any() || have_empty_use_order)
-      tbl->keys_in_use_for_order_by&= index_order[INDEX_HINT_USE];
-    if (index_group[INDEX_HINT_USE].any() || have_empty_use_group)
-      tbl->keys_in_use_for_group_by&= index_group[INDEX_HINT_USE];
+    if (!index_join[INDEX_HINT_USE].is_clear_all() || have_empty_use_join)
+      tbl->keys_in_use_for_query.intersect(index_join[INDEX_HINT_USE]);
+    if (!index_order[INDEX_HINT_USE].is_clear_all() || have_empty_use_order)
+      tbl->keys_in_use_for_order_by.intersect (index_order[INDEX_HINT_USE]);
+    if (!index_group[INDEX_HINT_USE].is_clear_all() || have_empty_use_group)
+      tbl->keys_in_use_for_group_by.intersect (index_group[INDEX_HINT_USE]);
 
     /* apply IGNORE INDEX */
-    key_map_subtract(tbl->keys_in_use_for_query, index_join[INDEX_HINT_IGNORE]);
-    key_map_subtract(tbl->keys_in_use_for_order_by, index_order[INDEX_HINT_IGNORE]);
-    key_map_subtract(tbl->keys_in_use_for_group_by, index_group[INDEX_HINT_IGNORE]);
+    tbl->keys_in_use_for_query.subtract (index_join[INDEX_HINT_IGNORE]);
+    tbl->keys_in_use_for_order_by.subtract (index_order[INDEX_HINT_IGNORE]);
+    tbl->keys_in_use_for_group_by.subtract (index_group[INDEX_HINT_IGNORE]);
   }
 
   /* make sure covering_keys don't include indexes disabled with a hint */
-  tbl->covering_keys&= tbl->keys_in_use_for_query;
+  tbl->covering_keys.intersect(tbl->keys_in_use_for_query);
   return 0;
 }
 
@@ -3203,14 +3234,14 @@
   uint32_t  copy_func_count= param->func_count;
   uint32_t  hidden_null_count, hidden_null_pack_length, hidden_field_count;
   uint32_t  blob_count,group_null_items, string_count;
-  uint32_t  temp_pool_slot= BIT_NONE;
+  uint32_t  temp_pool_slot= MY_BIT_NONE;
   uint32_t fieldnr= 0;
   ulong reclength, string_total_length;
   bool  using_unique_constraint= 0;
   bool  use_packed_rows= 0;
   bool  not_all_columns= !(select_options & TMP_TABLE_ALL_COLUMNS);
   char  *tmpname,path[FN_REFLEN];
-  unsigned char	*pos, *group_buff;
+  unsigned char	*pos, *group_buff, *bitmaps;
   unsigned char *null_flags;
   Field **reg_field, **from_field, **default_field;
   uint32_t *blob_field;
@@ -3227,7 +3258,7 @@
   if (use_temp_pool && !(test_flags & TEST_KEEP_TMP_TABLES))
     setNextBit(temp_pool);
 
-  if (temp_pool_slot != BIT_NONE) // we got a slot
+  if (temp_pool_slot != MY_BIT_NONE) // we got a slot
     sprintf(path, "%s_%lx_%i", TMP_FILE_PREFIX,
             (unsigned long)current_pid, temp_pool_slot);
   else
@@ -3297,16 +3328,17 @@
                         &tmpname, (uint32_t) strlen(path)+1,
                         &group_buff, (group && ! using_unique_constraint ?
                                       param->group_length : 0),
+                        &bitmaps, bitmap_buffer_size(field_count)*2,
                         NULL))
   {
-    if (temp_pool_slot != BIT_NONE)
+    if (temp_pool_slot != MY_BIT_NONE)
       temp_pool.reset(temp_pool_slot);
     return(NULL);				/* purecov: inspected */
   }
   /* Copy_field belongs to Tmp_Table_Param, allocate it in Session mem_root */
   if (!(param->copy_field= copy= new (session->mem_root) Copy_field[field_count]))
   {
-    if (temp_pool_slot != BIT_NONE)
+    if (temp_pool_slot != MY_BIT_NONE)
       temp_pool.reset(temp_pool_slot);
     free_root(&own_root, MYF(0));               /* purecov: inspected */
     return(NULL);				/* purecov: inspected */
@@ -3332,9 +3364,9 @@
   table->temp_pool_slot= temp_pool_slot;
   table->copy_blobs= 1;
   table->in_use= session;
-  table->quick_keys.reset();
-  table->covering_keys.reset();
-  table->keys_in_use_for_query.reset();
+  table->quick_keys.init();
+  table->covering_keys.init();
+  table->keys_in_use_for_query.init();
 
   table->setShare(share);
   share->init(tmpname, tmpname);
@@ -3343,8 +3375,8 @@
   share->db_low_byte_first=1;                // True for HEAP and MyISAM
   share->table_charset= param->table_charset;
   share->primary_key= MAX_KEY;               // Indicate no primary key
-  share->keys_for_keyread.reset();
-  share->keys_in_use.reset();
+  share->keys_for_keyread.init();
+  share->keys_in_use.init();
 
   /* Calculate which type of fields we will store in the temporary table */
 
@@ -3858,7 +3890,7 @@
 err:
   session->mem_root= mem_root_save;
   table->free_tmp_table(session);                    /* purecov: inspected */
-  if (temp_pool_slot != BIT_NONE)
+  if (temp_pool_slot != MY_BIT_NONE)
     temp_pool.reset(temp_pool_slot);
   return(NULL);				/* purecov: inspected */
 }
@@ -3894,6 +3926,7 @@
   uint32_t null_count= 0;                 /* number of columns which may be null */
   uint32_t null_pack_length;              /* NULL representation array length */
   uint32_t *blob_field;
+  unsigned char *bitmaps;
   Table *table;
   TableShare *share;
 
@@ -3902,6 +3935,7 @@
                         &share, sizeof(*share),
                         &field, (field_count + 1) * sizeof(Field*),
                         &blob_field, (field_count+1) *sizeof(uint32_t),
+                        &bitmaps, bitmap_buffer_size(field_count)*2,
                         NULL))
     return 0;
 
@@ -4166,7 +4200,7 @@
     (*ptr)->free();
   free_io_cache(this);
 
-  if (temp_pool_slot != BIT_NONE)
+  if (temp_pool_slot != MY_BIT_NONE)
     temp_pool.reset(temp_pool_slot);
 
   free_root(&own_root, MYF(0)); /* the table is allocated in its own root */
@@ -4298,11 +4332,11 @@
 {
   uint32_t min_length= UINT32_MAX;
   uint32_t best= MAX_KEY;
-  if (usable_keys->any())
+  if (!usable_keys->is_clear_all())
   {
     for (uint32_t nr=0; nr < s->keys ; nr++)
     {
-      if (usable_keys->test(nr))
+      if (usable_keys->is_set(nr))
       {
         if (key_info[nr].key_length < min_length)
         {
@@ -4453,7 +4487,7 @@
   map= (table_map) 1 << table_number;
   force_index= table_list->force_index;
   covering_keys= s->keys_for_keyread;
-  merge_keys.reset();
+  merge_keys.clear_all();
 }
 
 

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2009-05-04 21:06:03 +0000
+++ drizzled/table.h	2009-05-08 19:07:39 +0000
@@ -162,6 +162,7 @@
   order_st *group;
   const char	*alias;            	  /* alias or table name */
   unsigned char		*null_flags;
+  my_bitmap_map	*bitmap_init_value;
   std::bitset<MAX_FIELDS> def_read_set, def_write_set, tmp_set; /* containers */
   std::bitset<MAX_FIELDS> *read_set, *write_set;                /* Active column sets */
   /*
@@ -185,7 +186,7 @@
   query_id_t	query_id;
 
   /*
-    For each key that has quick_keys.test(key) == true: estimate of #records
+    For each key that has quick_keys.is_set(key) == true: estimate of #records
     and max #key parts that range access would use.
   */
   ha_rows	quick_rows[MAX_KEY];
@@ -267,9 +268,11 @@
   */
   bool open_placeholder;
   bool locked_by_logger;
+  bool no_replicate;
   bool locked_by_name;
   bool no_cache;
-
+  /* To signal that the table is associated with a HANDLER statement */
+  bool open_by_handler;
   /*
     To indicate that a non-null value of the auto_increment field
     was provided by the user or retrieved from the current record.
@@ -300,6 +303,8 @@
   {
     read_set= read_set_arg;
     write_set= write_set_arg;
+    if (file)
+      file->column_bitmaps_signal();
   }
   inline void column_bitmaps_set_no_signal(std::bitset<MAX_FIELDS> *read_set_arg,
                                            std::bitset<MAX_FIELDS> *write_set_arg)

=== modified file 'drizzled/table_share.h'
--- drizzled/table_share.h	2009-05-04 22:41:24 +0000
+++ drizzled/table_share.h	2009-05-08 19:07:39 +0000
@@ -106,6 +106,8 @@
   uint32_t null_bytes;
   uint32_t last_null_bit_pos;
   uint32_t fields;				/* Number of fields */
+  uint32_t stored_fields;                   /* Number of stored fields
+                                           (i.e. without generated-only ones) */
   uint32_t rec_buff_length;                 /* Size of table->record[] buffer */
   uint32_t keys, key_parts;
   uint32_t max_key_length, max_unique_length, total_key_length;

=== added file 'mysys/my_bitmap.cc'
--- mysys/my_bitmap.cc	1970-01-01 00:00:00 +0000
+++ mysys/my_bitmap.cc	2009-05-08 19:07:39 +0000
@@ -0,0 +1,1110 @@
+/* Copyright (C) 2000 MySQL AB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+
+/*
+  Handling of unsigned char arrays as large bitmaps.
+
+  API limitations (or, rather asserted safety assumptions,
+  to encourage correct programming)
+
+    * the internal size is a set of 32 bit words
+    * the number of bits specified in creation can be any number > 0
+    * there are THREAD safe versions of most calls called bitmap_lock_*
+      many of those are not used and not compiled normally but the code
+      already exist for them in an #ifdef:ed part. These can only be used
+      if THREAD was specified in bitmap_init
+
+  TODO:
+  Make assembler THREAD safe versions of these using test-and-set instructions
+
+  Original version created by Sergei Golubchik 2001 - 2004.
+  New version written and test program added and some changes to the interface
+  was made by Mikael Ronström 2005, with assistance of Tomas Ulin and Mats
+  Kindahl.
+*/
+
+#include "mysys_priv.h"
+#include <mysys/my_bitmap.h>
+#include <mystrings/m_string.h>
+#include <mysys/my_bit.h>
+
+void create_last_word_mask(MY_BITMAP *map)
+{
+  /* Get the number of used bits (1..8) in the last byte */
+  unsigned int const used= 1U + ((map->n_bits-1U) & 0x7U);
+
+  /*
+    Create a mask with the upper 'unused' bits set and the lower 'used'
+    bits clear. The bits within each byte is stored in big-endian order.
+   */
+  unsigned char const mask= (~((1 << used) - 1)) & 255;
+
+  /*
+    The first bytes are to be set to zero since they represent real  bits
+    in the bitvector. The last bytes are set to 0xFF since they  represent
+    bytes not used by the bitvector. Finally the last byte contains  bits
+    as set by the mask above.
+  */
+  unsigned char *ptr= (unsigned char*)&map->last_word_mask;
+
+  map->last_word_ptr= map->bitmap + no_words_in_map(map)-1;
+  switch (no_bytes_in_map(map) & 3) {
+  case 1:
+    map->last_word_mask= UINT32_MAX;
+    ptr[0]= mask;
+    return;
+  case 2:
+    map->last_word_mask= UINT32_MAX;
+    ptr[0]= 0;
+    ptr[1]= mask;
+    return;
+  case 3:
+    map->last_word_mask= 0;
+    ptr[2]= mask;
+    ptr[3]= 0xFFU;
+    return;
+  case 0:
+    map->last_word_mask= 0U;
+    ptr[3]= mask;
+    return;
+  }
+}
+
+
+static inline void bitmap_lock(MY_BITMAP *map)
+{
+  if (map->mutex)
+    pthread_mutex_lock(map->mutex);
+}
+
+static inline void bitmap_unlock(MY_BITMAP *map)
+{
+  if (map->mutex)
+    pthread_mutex_unlock(map->mutex);
+}
+
+
+bool bitmap_init(MY_BITMAP *map, my_bitmap_map *buf, uint32_t n_bits, bool thread_safe)
+{
+  if (!buf)
+  {
+    uint32_t size_in_bytes= bitmap_buffer_size(n_bits);
+    uint32_t extra= 0;
+    if (thread_safe)
+    {
+      size_in_bytes= ALIGN_SIZE(size_in_bytes);
+      extra= sizeof(pthread_mutex_t);
+    }
+    map->mutex= 0;
+    if (!(buf= (my_bitmap_map*) malloc(size_in_bytes+extra)))
+      return(1);
+    if (thread_safe)
+    {
+      map->mutex= (pthread_mutex_t *) ((char*) buf + size_in_bytes);
+      pthread_mutex_init(map->mutex, MY_MUTEX_INIT_FAST);
+    }
+  }
+  else
+  {
+    assert(thread_safe == 0);
+  }
+
+  map->bitmap= buf;
+  map->n_bits= n_bits;
+  create_last_word_mask(map);
+  bitmap_clear_all(map);
+  return(0);
+}
+
+
+void bitmap_free(MY_BITMAP *map)
+{
+  if (map->bitmap)
+  {
+    if (map->mutex)
+      pthread_mutex_destroy(map->mutex);
+    free((char*) map->bitmap);
+    map->bitmap=0;
+  }
+  return;
+}
+
+
+/*
+  test if bit already set and set it if it was not (thread unsafe method)
+
+  SYNOPSIS
+    bitmap_fast_test_and_set()
+    MAP   bit map struct
+    BIT   bit number
+
+  RETURN
+    0    bit was not set
+    !=0  bit was set
+*/
+
+bool bitmap_fast_test_and_set(MY_BITMAP *map, uint32_t bitmap_bit)
+{
+  unsigned char *value= ((unsigned char*) map->bitmap) + (bitmap_bit / 8);
+  unsigned char bit= 1 << ((bitmap_bit) & 7);
+  unsigned char res= (*value) & bit;
+  *value|= bit;
+  return res;
+}
+
+
+/*
+  test if bit already set and set it if it was not (thread safe method)
+
+  SYNOPSIS
+    bitmap_fast_test_and_set()
+    map          bit map struct
+    bitmap_bit   bit number
+
+  RETURN
+    0    bit was not set
+    !=0  bit was set
+*/
+
+bool bitmap_test_and_set(MY_BITMAP *map, uint32_t bitmap_bit)
+{
+  bool res;
+  assert(map->bitmap && bitmap_bit < map->n_bits);
+  bitmap_lock(map);
+  res= bitmap_fast_test_and_set(map, bitmap_bit);
+  bitmap_unlock(map);
+  return res;
+}
+
+/*
+  test if bit already set and clear it if it was set(thread unsafe method)
+
+  SYNOPSIS
+    bitmap_fast_test_and_set()
+    MAP   bit map struct
+    BIT   bit number
+
+  RETURN
+    0    bit was not set
+    !=0  bit was set
+*/
+
+bool bitmap_fast_test_and_clear(MY_BITMAP *map, uint32_t bitmap_bit)
+{
+  unsigned char *byte= (unsigned char*) map->bitmap + (bitmap_bit / 8);
+  unsigned char bit= 1 << ((bitmap_bit) & 7);
+  unsigned char res= (*byte) & bit;
+  *byte&= ~bit;
+  return res;
+}
+
+
+bool bitmap_test_and_clear(MY_BITMAP *map, uint32_t bitmap_bit)
+{
+  bool res;
+  assert(map->bitmap && bitmap_bit < map->n_bits);
+  bitmap_lock(map);
+  res= bitmap_fast_test_and_clear(map, bitmap_bit);
+  bitmap_unlock(map);
+  return res;
+}
+
+
+uint32_t bitmap_set_next(MY_BITMAP *map)
+{
+  uint32_t bit_found;
+  assert(map->bitmap);
+  if ((bit_found= bitmap_get_first(map)) != MY_BIT_NONE)
+    bitmap_set_bit(map, bit_found);
+  return bit_found;
+}
+
+
+void bitmap_set_prefix(MY_BITMAP *map, uint32_t prefix_size)
+{
+  uint32_t prefix_bytes, prefix_bits, d;
+  unsigned char *m= (unsigned char *)map->bitmap;
+
+  assert(map->bitmap &&
+	      (prefix_size <= map->n_bits || prefix_size == UINT32_MAX));
+  set_if_smaller(prefix_size, map->n_bits);
+  if ((prefix_bytes= prefix_size / 8))
+    memset(m, 0xff, prefix_bytes);
+  m+= prefix_bytes;
+  if ((prefix_bits= prefix_size & 7))
+    *m++= (1 << prefix_bits)-1;
+  if ((d= no_bytes_in_map(map)-prefix_bytes))
+    memset(m, 0, d);
+}
+
+
+bool bitmap_is_prefix(const MY_BITMAP *map, uint32_t prefix_size)
+{
+  uint32_t prefix_bits= prefix_size & 0x7, res;
+  unsigned char *m= (unsigned char*)map->bitmap;
+  unsigned char *end_prefix= m+prefix_size/8;
+  unsigned char *end;
+  assert(m && prefix_size <= map->n_bits);
+  end= m+no_bytes_in_map(map);
+
+  while (m < end_prefix)
+    if (*m++ != 0xff)
+      return 0;
+
+  *map->last_word_ptr&= ~map->last_word_mask; /*Clear bits*/
+  res= 0;
+  if (prefix_bits && *m++ != (1 << prefix_bits)-1)
+    goto ret;
+
+  while (m < end)
+    if (*m++ != 0)
+      goto ret;
+  res= 1;
+ret:
+  return res;
+}
+
+
+bool bitmap_is_set_all(const MY_BITMAP *map)
+{
+  my_bitmap_map *data_ptr= map->bitmap;
+  my_bitmap_map *end= map->last_word_ptr;
+  *map->last_word_ptr |= map->last_word_mask;
+  for (; data_ptr <= end; data_ptr++)
+    if (*data_ptr != 0xFFFFFFFF)
+      return false;
+  return true;
+}
+
+
+bool bitmap_is_clear_all(const MY_BITMAP *map)
+{
+  my_bitmap_map *data_ptr= map->bitmap;
+  my_bitmap_map *end;
+  if (*map->last_word_ptr & ~map->last_word_mask)
+    return false;
+  end= map->last_word_ptr;
+  for (; data_ptr < end; data_ptr++)
+    if (*data_ptr)
+      return false;
+  return true;
+}
+
+/* Return true if map1 is a subset of map2 */
+
+bool bitmap_is_subset(const MY_BITMAP *map1, const MY_BITMAP *map2)
+{
+  my_bitmap_map *m1= map1->bitmap, *m2= map2->bitmap, *end;
+
+  assert(map1->bitmap && map2->bitmap &&
+              map1->n_bits==map2->n_bits);
+
+  end= map1->last_word_ptr;
+  *map1->last_word_ptr &= ~map1->last_word_mask;
+  *map2->last_word_ptr &= ~map2->last_word_mask;
+  while (m1 <= end)
+  {
+    if ((*m1++) & ~(*m2++))
+      return 0;
+  }
+  return 1;
+}
+
+/* True if bitmaps has any common bits */
+
+bool bitmap_is_overlapping(const MY_BITMAP *map1, const MY_BITMAP *map2)
+{
+  my_bitmap_map *m1= map1->bitmap, *m2= map2->bitmap, *end;
+
+  assert(map1->bitmap && map2->bitmap &&
+              map1->n_bits==map2->n_bits);
+
+  end= map1->last_word_ptr;
+  *map1->last_word_ptr &= ~map1->last_word_mask;
+  *map2->last_word_ptr &= ~map2->last_word_mask;
+  while (m1 <= end)
+  {
+    if ((*m1++) & (*m2++))
+      return 1;
+  }
+  return 0;
+}
+
+
+void bitmap_intersect(MY_BITMAP *map, const MY_BITMAP *map2)
+{
+  my_bitmap_map *to= map->bitmap, *from= map2->bitmap, *end;
+  uint32_t len= no_words_in_map(map), len2 = no_words_in_map(map2);
+
+  assert(map->bitmap && map2->bitmap);
+
+  end= to+cmin(len,len2);
+  *map2->last_word_ptr&= ~map2->last_word_mask; /*Clear last bits in map2*/
+  while (to < end)
+    *to++ &= *from++;
+
+  if (len2 < len)
+  {
+    end+=len-len2;
+    while (to < end)
+      *to++=0;
+  }
+}
+
+
+/*
+  Set/clear all bits above a bit.
+
+  SYNOPSIS
+    bitmap_set_above()
+    map                  RETURN The bitmap to change.
+    from_byte                   The bitmap buffer byte offset to start with.
+    use_bit                     The bit value (1/0) to use for all upper bits.
+
+  NOTE
+    You can only set/clear full bytes.
+    The function is meant for the situation that you copy a smaller bitmap
+    to a bigger bitmap. Bitmap lengths are always multiple of eigth (the
+    size of a byte). Using 'from_byte' saves multiplication and division
+    by eight during parameter passing.
+
+  RETURN
+    void
+*/
+
+void bitmap_set_above(MY_BITMAP *map, uint32_t from_byte, uint32_t use_bit)
+{
+  unsigned char use_byte= use_bit ? 0xff : 0;
+  unsigned char *to= (unsigned char *)map->bitmap + from_byte;
+  unsigned char *end= (unsigned char *)map->bitmap + (map->n_bits+7)/8;
+
+  while (to < end)
+    *to++= use_byte;
+}
+
+
+void bitmap_subtract(MY_BITMAP *map, const MY_BITMAP *map2)
+{
+  my_bitmap_map *to= map->bitmap, *from= map2->bitmap, *end;
+  assert(map->bitmap && map2->bitmap &&
+              map->n_bits==map2->n_bits);
+
+  end= map->last_word_ptr;
+
+  while (to <= end)
+    *to++ &= ~(*from++);
+}
+
+
+void bitmap_union(MY_BITMAP *map, const MY_BITMAP *map2)
+{
+  my_bitmap_map *to= map->bitmap, *from= map2->bitmap, *end;
+
+  assert(map->bitmap && map2->bitmap &&
+              map->n_bits==map2->n_bits);
+  end= map->last_word_ptr;
+
+  while (to <= end)
+    *to++ |= *from++;
+}
+
+
+void bitmap_xor(MY_BITMAP *map, const MY_BITMAP *map2)
+{
+  my_bitmap_map *to= map->bitmap, *from= map2->bitmap, *end= map->last_word_ptr;
+  assert(map->bitmap && map2->bitmap &&
+              map->n_bits==map2->n_bits);
+  while (to <= end)
+    *to++ ^= *from++;
+}
+
+
+void bitmap_invert(MY_BITMAP *map)
+{
+  my_bitmap_map *to= map->bitmap, *end;
+
+  assert(map->bitmap);
+  end= map->last_word_ptr;
+
+  while (to <= end)
+    *to++ ^= 0xFFFFFFFF;
+}
+
+
+uint32_t bitmap_bits_set(const MY_BITMAP *map)
+{
+  unsigned char *m= (unsigned char*)map->bitmap;
+  unsigned char *end= m + no_bytes_in_map(map);
+  uint32_t res= 0;
+
+  assert(map->bitmap);
+  *map->last_word_ptr&= ~map->last_word_mask; /*Reset last bits to zero*/
+  while (m < end)
+    res+= my_count_bits_uint16(*m++);
+  return res;
+}
+
+
+void bitmap_copy(MY_BITMAP *map, const MY_BITMAP *map2)
+{
+  my_bitmap_map *to= map->bitmap, *from= map2->bitmap, *end;
+
+  assert(map->bitmap && map2->bitmap &&
+              map->n_bits==map2->n_bits);
+  end= map->last_word_ptr;
+  while (to <= end)
+    *to++ = *from++;
+}
+
+
+uint32_t bitmap_get_first_set(const MY_BITMAP *map)
+{
+  unsigned char *byte_ptr;
+  uint32_t i,j,k;
+  my_bitmap_map *data_ptr, *end= map->last_word_ptr;
+
+  assert(map->bitmap);
+  data_ptr= map->bitmap;
+  *map->last_word_ptr &= ~map->last_word_mask;
+
+  for (i=0; data_ptr <= end; data_ptr++, i++)
+  {
+    if (*data_ptr)
+    {
+      byte_ptr= (unsigned char*)data_ptr;
+      for (j=0; ; j++, byte_ptr++)
+      {
+        if (*byte_ptr)
+        {
+          for (k=0; ; k++)
+          {
+            if (*byte_ptr & (1 << k))
+              return (i*32) + (j*8) + k;
+          }
+        }
+      }
+    }
+  }
+  return MY_BIT_NONE;
+}
+
+
+uint32_t bitmap_get_first(const MY_BITMAP *map)
+{
+  unsigned char *byte_ptr;
+  uint32_t i,j,k;
+  my_bitmap_map *data_ptr, *end= map->last_word_ptr;
+
+  assert(map->bitmap);
+  data_ptr= map->bitmap;
+  *map->last_word_ptr|= map->last_word_mask;
+
+  for (i=0; data_ptr <= end; data_ptr++, i++)
+  {
+    if (*data_ptr != 0xFFFFFFFF)
+    {
+      byte_ptr= (unsigned char*)data_ptr;
+      for (j=0; ; j++, byte_ptr++)
+      {
+        if (*byte_ptr != 0xFF)
+        {
+          for (k=0; ; k++)
+          {
+            if (!(*byte_ptr & (1 << k)))
+              return (i*32) + (j*8) + k;
+          }
+        }
+      }
+    }
+  }
+  return MY_BIT_NONE;
+}
+
+
+uint32_t bitmap_lock_set_next(MY_BITMAP *map)
+{
+  uint32_t bit_found;
+  bitmap_lock(map);
+  bit_found= bitmap_set_next(map);
+  bitmap_unlock(map);
+  return bit_found;
+}
+
+
+void bitmap_lock_clear_bit(MY_BITMAP *map, uint32_t bitmap_bit)
+{
+  bitmap_lock(map);
+  assert(map->bitmap && bitmap_bit < map->n_bits);
+  bitmap_clear_bit(map, bitmap_bit);
+  bitmap_unlock(map);
+}
+
+
+#ifdef NOT_USED
+bool bitmap_lock_is_prefix(const MY_BITMAP *map, uint32_t prefix_size)
+{
+  bool res;
+  bitmap_lock((MY_BITMAP *)map);
+  res= bitmap_is_prefix(map, prefix_size);
+  bitmap_unlock((MY_BITMAP *)map);
+  return res;
+}
+
+
+void bitmap_lock_set_all(MY_BITMAP *map)
+{
+  bitmap_lock(map);
+  bitmap_set_all(map);
+  bitmap_unlock(map);
+}
+
+
+void bitmap_lock_clear_all(MY_BITMAP *map)
+{
+  bitmap_lock(map);
+  bitmap_clear_all(map);
+  bitmap_unlock(map);
+}
+
+
+void bitmap_lock_set_prefix(MY_BITMAP *map, uint32_t prefix_size)
+{
+  bitmap_lock(map);
+  bitmap_set_prefix(map, prefix_size);
+  bitmap_unlock(map);
+}
+
+
+bool bitmap_lock_is_clear_all(const MY_BITMAP *map)
+{
+  uint32_t res;
+  bitmap_lock((MY_BITMAP *)map);
+  res= bitmap_is_clear_all(map);
+  bitmap_unlock((MY_BITMAP *)map);
+  return res;
+}
+
+
+bool bitmap_lock_is_set_all(const MY_BITMAP *map)
+{
+  uint32_t res;
+  bitmap_lock((MY_BITMAP *)map);
+  res= bitmap_is_set_all(map);
+  bitmap_unlock((MY_BITMAP *)map);
+  return res;
+}
+
+
+bool bitmap_lock_is_set(const MY_BITMAP *map, uint32_t bitmap_bit)
+{
+  bool res;
+  assert(map->bitmap && bitmap_bit < map->n_bits);
+  bitmap_lock((MY_BITMAP *)map);
+  res= bitmap_is_set(map, bitmap_bit);
+  bitmap_unlock((MY_BITMAP *)map);
+  return res;
+}
+
+
+bool bitmap_lock_is_subset(const MY_BITMAP *map1, const MY_BITMAP *map2)
+{
+  uint32_t res;
+  bitmap_lock((MY_BITMAP *)map1);
+  bitmap_lock((MY_BITMAP *)map2);
+  res= bitmap_is_subset(map1, map2);
+  bitmap_unlock((MY_BITMAP *)map2);
+  bitmap_unlock((MY_BITMAP *)map1);
+  return res;
+}
+
+
+bool bitmap_lock_cmp(const MY_BITMAP *map1, const MY_BITMAP *map2)
+{
+  uint32_t res;
+
+  assert(map1->bitmap && map2->bitmap &&
+              map1->n_bits==map2->n_bits);
+  bitmap_lock((MY_BITMAP *)map1);
+  bitmap_lock((MY_BITMAP *)map2);
+  res= bitmap_cmp(map1, map2);
+  bitmap_unlock((MY_BITMAP *)map2);
+  bitmap_unlock((MY_BITMAP *)map1);
+  return res;
+}
+
+
+void bitmap_lock_intersect(MY_BITMAP *map, const MY_BITMAP *map2)
+{
+  bitmap_lock(map);
+  bitmap_lock((MY_BITMAP *)map2);
+  bitmap_intersect(map, map2);
+  bitmap_unlock((MY_BITMAP *)map2);
+  bitmap_unlock(map);
+}
+
+
+void bitmap_lock_subtract(MY_BITMAP *map, const MY_BITMAP *map2)
+{
+  bitmap_lock(map);
+  bitmap_lock((MY_BITMAP *)map2);
+  bitmap_subtract(map, map2);
+  bitmap_unlock((MY_BITMAP *)map2);
+  bitmap_unlock(map);
+}
+
+
+void bitmap_lock_union(MY_BITMAP *map, const MY_BITMAP *map2)
+{
+  bitmap_lock(map);
+  bitmap_lock((MY_BITMAP *)map2);
+  bitmap_union(map, map2);
+  bitmap_unlock((MY_BITMAP *)map2);
+  bitmap_unlock(map);
+}
+
+
+/*
+  SYNOPSIS
+    bitmap_bits_set()
+      map
+  RETURN
+    Number of set bits in the bitmap.
+*/
+uint32_t bitmap_lock_bits_set(const MY_BITMAP *map)
+{
+  uint32_t res;
+  bitmap_lock((MY_BITMAP *)map);
+  assert(map->bitmap);
+  res= bitmap_bits_set(map);
+  bitmap_unlock((MY_BITMAP *)map);
+  return res;
+}
+
+
+/*
+  SYNOPSIS
+    bitmap_get_first()
+      map
+  RETURN
+    Number of first unset bit in the bitmap or MY_BIT_NONE if all bits are set.
+*/
+uint32_t bitmap_lock_get_first(const MY_BITMAP *map)
+{
+  uint32_t res;
+  bitmap_lock((MY_BITMAP*)map);
+  res= bitmap_get_first(map);
+  bitmap_unlock((MY_BITMAP*)map);
+  return res;
+}
+
+
+uint32_t bitmap_lock_get_first_set(const MY_BITMAP *map)
+{
+  uint32_t res;
+  bitmap_lock((MY_BITMAP*)map);
+  res= bitmap_get_first_set(map);
+  bitmap_unlock((MY_BITMAP*)map);
+  return res;
+}
+
+
+void bitmap_lock_set_bit(MY_BITMAP *map, uint32_t bitmap_bit)
+{
+  assert(map->bitmap && bitmap_bit < map->n_bits);
+  bitmap_lock(map);
+  bitmap_set_bit(map, bitmap_bit);
+  bitmap_unlock(map);
+}
+
+
+void bitmap_lock_flip_bit(MY_BITMAP *map, uint32_t bitmap_bit)
+{
+  assert(map->bitmap && bitmap_bit < map->n_bits);
+  bitmap_lock(map);
+  bitmap_flip_bit(map, bitmap_bit);
+  bitmap_unlock(map);
+}
+#endif
+#ifdef MAIN
+
+uint32_t get_rand_bit(uint32_t bitsize)
+{
+  return (rand() % bitsize);
+}
+
+bool test_set_get_clear_bit(MY_BITMAP *map, uint32_t bitsize)
+{
+  uint32_t i, test_bit;
+  uint32_t no_loops= bitsize > 128 ? 128 : bitsize;
+  for (i=0; i < no_loops; i++)
+  {
+    test_bit= get_rand_bit(bitsize);
+    bitmap_set_bit(map, test_bit);
+    if (!bitmap_is_set(map, test_bit))
+      goto error1;
+    bitmap_clear_bit(map, test_bit);
+    if (bitmap_is_set(map, test_bit))
+      goto error2;
+  }
+  return false;
+error1:
+  printf("Error in set bit, bit %u, bitsize = %u", test_bit, bitsize);
+  return true;
+error2:
+  printf("Error in clear bit, bit %u, bitsize = %u", test_bit, bitsize);
+  return true;
+}
+
+bool test_flip_bit(MY_BITMAP *map, uint32_t bitsize)
+{
+  uint32_t i, test_bit;
+  uint32_t no_loops= bitsize > 128 ? 128 : bitsize;
+  for (i=0; i < no_loops; i++)
+  {
+    test_bit= get_rand_bit(bitsize);
+    bitmap_flip_bit(map, test_bit);
+    if (!bitmap_is_set(map, test_bit))
+      goto error1;
+    bitmap_flip_bit(map, test_bit);
+    if (bitmap_is_set(map, test_bit))
+      goto error2;
+  }
+  return false;
+error1:
+  printf("Error in flip bit 1, bit %u, bitsize = %u", test_bit, bitsize);
+  return true;
+error2:
+  printf("Error in flip bit 2, bit %u, bitsize = %u", test_bit, bitsize);
+  return true;
+}
+
+bool test_operators(MY_BITMAP *, uint32_t)
+{
+  return false;
+}
+
+bool test_get_all_bits(MY_BITMAP *map, uint32_t bitsize)
+{
+  uint32_t i;
+  bitmap_set_all(map);
+  if (!bitmap_is_set_all(map))
+    goto error1;
+  if (!bitmap_is_prefix(map, bitsize))
+    goto error5;
+  bitmap_clear_all(map);
+  if (!bitmap_is_clear_all(map))
+    goto error2;
+  if (!bitmap_is_prefix(map, 0))
+    goto error6;
+  for (i=0; i<bitsize;i++)
+    bitmap_set_bit(map, i);
+  if (!bitmap_is_set_all(map))
+    goto error3;
+  for (i=0; i<bitsize;i++)
+    bitmap_clear_bit(map, i);
+  if (!bitmap_is_clear_all(map))
+    goto error4;
+  return false;
+error1:
+  printf("Error in set_all, bitsize = %u", bitsize);
+  return true;
+error2:
+  printf("Error in clear_all, bitsize = %u", bitsize);
+  return true;
+error3:
+  printf("Error in bitmap_is_set_all, bitsize = %u", bitsize);
+  return true;
+error4:
+  printf("Error in bitmap_is_clear_all, bitsize = %u", bitsize);
+  return true;
+error5:
+  printf("Error in set_all through set_prefix, bitsize = %u", bitsize);
+  return true;
+error6:
+  printf("Error in clear_all through set_prefix, bitsize = %u", bitsize);
+  return true;
+}
+
+bool test_compare_operators(MY_BITMAP *map, uint32_t bitsize)
+{
+  uint32_t i, j, test_bit1, test_bit2, test_bit3,test_bit4;
+  uint32_t no_loops= bitsize > 128 ? 128 : bitsize;
+  MY_BITMAP map2_obj, map3_obj;
+  MY_BITMAP *map2= &map2_obj, *map3= &map3_obj;
+  my_bitmap_map map2buf[1024];
+  my_bitmap_map map3buf[1024];
+  bitmap_init(&map2_obj, map2buf, bitsize, false);
+  bitmap_init(&map3_obj, map3buf, bitsize, false);
+  bitmap_clear_all(map2);
+  bitmap_clear_all(map3);
+  for (i=0; i < no_loops; i++)
+  {
+    test_bit1=get_rand_bit(bitsize);
+    bitmap_set_prefix(map, test_bit1);
+    test_bit2=get_rand_bit(bitsize);
+    bitmap_set_prefix(map2, test_bit2);
+    bitmap_intersect(map, map2);
+    test_bit3= test_bit2 < test_bit1 ? test_bit2 : test_bit1;
+    bitmap_set_prefix(map3, test_bit3);
+    if (!bitmap_cmp(map, map3))
+      goto error1;
+    bitmap_clear_all(map);
+    bitmap_clear_all(map2);
+    bitmap_clear_all(map3);
+    test_bit1=get_rand_bit(bitsize);
+    test_bit2=get_rand_bit(bitsize);
+    test_bit3=get_rand_bit(bitsize);
+    bitmap_set_prefix(map, test_bit1);
+    bitmap_set_prefix(map2, test_bit2);
+    test_bit3= test_bit2 > test_bit1 ? test_bit2 : test_bit1;
+    bitmap_set_prefix(map3, test_bit3);
+    bitmap_union(map, map2);
+    if (!bitmap_cmp(map, map3))
+      goto error2;
+    bitmap_clear_all(map);
+    bitmap_clear_all(map2);
+    bitmap_clear_all(map3);
+    test_bit1=get_rand_bit(bitsize);
+    test_bit2=get_rand_bit(bitsize);
+    test_bit3=get_rand_bit(bitsize);
+    bitmap_set_prefix(map, test_bit1);
+    bitmap_set_prefix(map2, test_bit2);
+    bitmap_xor(map, map2);
+    test_bit3= test_bit2 > test_bit1 ? test_bit2 : test_bit1;
+    test_bit4= test_bit2 < test_bit1 ? test_bit2 : test_bit1;
+    bitmap_set_prefix(map3, test_bit3);
+    for (j=0; j < test_bit4; j++)
+      bitmap_clear_bit(map3, j);
+    if (!bitmap_cmp(map, map3))
+      goto error3;
+    bitmap_clear_all(map);
+    bitmap_clear_all(map2);
+    bitmap_clear_all(map3);
+    test_bit1=get_rand_bit(bitsize);
+    test_bit2=get_rand_bit(bitsize);
+    test_bit3=get_rand_bit(bitsize);
+    bitmap_set_prefix(map, test_bit1);
+    bitmap_set_prefix(map2, test_bit2);
+    bitmap_subtract(map, map2);
+    if (test_bit2 < test_bit1)
+    {
+      bitmap_set_prefix(map3, test_bit1);
+      for (j=0; j < test_bit2; j++)
+        bitmap_clear_bit(map3, j);
+    }
+    if (!bitmap_cmp(map, map3))
+      goto error4;
+    bitmap_clear_all(map);
+    bitmap_clear_all(map2);
+    bitmap_clear_all(map3);
+    test_bit1=get_rand_bit(bitsize);
+    bitmap_set_prefix(map, test_bit1);
+    bitmap_invert(map);
+    bitmap_set_all(map3);
+    for (j=0; j < test_bit1; j++)
+      bitmap_clear_bit(map3, j);
+    if (!bitmap_cmp(map, map3))
+      goto error5;
+    bitmap_clear_all(map);
+    bitmap_clear_all(map3);
+  }
+  return false;
+error1:
+  printf("intersect error  bitsize=%u,size1=%u,size2=%u", bitsize,
+  test_bit1,test_bit2);
+  return true;
+error2:
+  printf("union error  bitsize=%u,size1=%u,size2=%u", bitsize,
+  test_bit1,test_bit2);
+  return true;
+error3:
+  printf("xor error  bitsize=%u,size1=%u,size2=%u", bitsize,
+  test_bit1,test_bit2);
+  return true;
+error4:
+  printf("subtract error  bitsize=%u,size1=%u,size2=%u", bitsize,
+  test_bit1,test_bit2);
+  return true;
+error5:
+  printf("invert error  bitsize=%u,size=%u", bitsize,
+  test_bit1);
+  return true;
+}
+
+bool test_count_bits_set(MY_BITMAP *map, uint32_t bitsize)
+{
+  uint32_t i, bit_count=0, test_bit;
+  uint32_t no_loops= bitsize > 128 ? 128 : bitsize;
+  for (i=0; i < no_loops; i++)
+  {
+    test_bit=get_rand_bit(bitsize);
+    if (!bitmap_is_set(map, test_bit))
+    {
+      bitmap_set_bit(map, test_bit);
+      bit_count++;
+    }
+  }
+  if (bit_count==0 && bitsize > 0)
+    goto error1;
+  if (bitmap_bits_set(map) != bit_count)
+    goto error2;
+  return false;
+error1:
+  printf("No bits set  bitsize = %u", bitsize);
+  return true;
+error2:
+  printf("Wrong count of bits set, bitsize = %u", bitsize);
+  return true;
+}
+
+bool test_get_first_bit(MY_BITMAP *map, uint32_t bitsize)
+{
+  uint32_t i, test_bit;
+  uint32_t no_loops= bitsize > 128 ? 128 : bitsize;
+  for (i=0; i < no_loops; i++)
+  {
+    test_bit=get_rand_bit(bitsize);
+    bitmap_set_bit(map, test_bit);
+    if (bitmap_get_first_set(map) != test_bit)
+      goto error1;
+    bitmap_set_all(map);
+    bitmap_clear_bit(map, test_bit);
+    if (bitmap_get_first(map) != test_bit)
+      goto error2;
+    bitmap_clear_all(map);
+  }
+  return false;
+error1:
+  printf("get_first_set error bitsize=%u,prefix_size=%u",bitsize,test_bit);
+  return true;
+error2:
+  printf("get_first error bitsize= %u, prefix_size= %u",bitsize,test_bit);
+  return true;
+}
+
+bool test_get_next_bit(MY_BITMAP *map, uint32_t bitsize)
+{
+  uint32_t i, j, test_bit;
+  uint32_t no_loops= bitsize > 128 ? 128 : bitsize;
+  for (i=0; i < no_loops; i++)
+  {
+    test_bit=get_rand_bit(bitsize);
+    for (j=0; j < test_bit; j++)
+      bitmap_set_next(map);
+    if (!bitmap_is_prefix(map, test_bit))
+      goto error1;
+    bitmap_clear_all(map);
+  }
+  return false;
+error1:
+  printf("get_next error  bitsize= %u, prefix_size= %u", bitsize,test_bit);
+  return true;
+}
+
+bool test_prefix(MY_BITMAP *map, uint32_t bitsize)
+{
+  uint32_t i, j, test_bit;
+  uint32_t no_loops= bitsize > 128 ? 128 : bitsize;
+  for (i=0; i < no_loops; i++)
+  {
+    test_bit=get_rand_bit(bitsize);
+    bitmap_set_prefix(map, test_bit);
+    if (!bitmap_is_prefix(map, test_bit))
+      goto error1;
+    bitmap_clear_all(map);
+    for (j=0; j < test_bit; j++)
+      bitmap_set_bit(map, j);
+    if (!bitmap_is_prefix(map, test_bit))
+      goto error2;
+    bitmap_set_all(map);
+    for (j=bitsize - 1; ~(j-test_bit); j--)
+      bitmap_clear_bit(map, j);
+    if (!bitmap_is_prefix(map, test_bit))
+      goto error3;
+    bitmap_clear_all(map);
+  }
+  return false;
+error1:
+  printf("prefix1 error  bitsize = %u, prefix_size = %u", bitsize,test_bit);
+  return true;
+error2:
+  printf("prefix2 error  bitsize = %u, prefix_size = %u", bitsize,test_bit);
+  return true;
+error3:
+  printf("prefix3 error  bitsize = %u, prefix_size = %u", bitsize,test_bit);
+  return true;
+}
+
+
+bool do_test(uint32_t bitsize)
+{
+  MY_BITMAP map;
+  my_bitmap_map buf[1024];
+  if (bitmap_init(&map, buf, bitsize, false))
+  {
+    printf("init error for bitsize %d", bitsize);
+    goto error;
+  }
+  if (test_set_get_clear_bit(&map,bitsize))
+    goto error;
+  bitmap_clear_all(&map);
+  if (test_flip_bit(&map,bitsize))
+    goto error;
+  bitmap_clear_all(&map);
+  if (test_operators(&map,bitsize))
+    goto error;
+  bitmap_clear_all(&map);
+  if (test_get_all_bits(&map, bitsize))
+    goto error;
+  bitmap_clear_all(&map);
+  if (test_compare_operators(&map,bitsize))
+    goto error;
+  bitmap_clear_all(&map);
+  if (test_count_bits_set(&map,bitsize))
+    goto error;
+  bitmap_clear_all(&map);
+  if (test_get_first_bit(&map,bitsize))
+    goto error;
+  bitmap_clear_all(&map);
+  if (test_get_next_bit(&map,bitsize))
+    goto error;
+  if (test_prefix(&map,bitsize))
+    goto error;
+  return false;
+error:
+  printf("\n");
+  return true;
+}
+
+int main()
+{
+  int i;
+  for (i= 1; i < 4096; i++)
+  {
+    printf("Start test for bitsize=%u\n",i);
+    if (do_test(i))
+      return -1;
+  }
+  printf("OK\n");
+  return 0;
+}
+
+/*
+  In directory mysys:
+  make test_bitmap
+  will build the bitmap tests and ./test_bitmap will execute it
+*/
+
+#endif

=== added file 'mysys/my_bitmap.h'
--- mysys/my_bitmap.h	1970-01-01 00:00:00 +0000
+++ mysys/my_bitmap.h	2009-05-08 19:07:39 +0000
@@ -0,0 +1,148 @@
+/* Copyright (C) 2000 MySQL AB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+
+#ifndef _my_bitmap_h_
+#define _my_bitmap_h_
+
+#define MY_BIT_NONE (~(uint32_t) 0)
+
+#include <mystrings/m_string.h>
+
+typedef uint32_t my_bitmap_map;
+
+typedef struct st_bitmap
+{
+  my_bitmap_map *bitmap;
+  uint32_t n_bits; /* number of bits occupied by the above */
+  my_bitmap_map last_word_mask;
+  my_bitmap_map *last_word_ptr;
+  /*
+     mutex will be acquired for the duration of each bitmap operation if
+     thread_safe flag in bitmap_init was set.  Otherwise, we optimize by not
+     acquiring the mutex
+   */
+  pthread_mutex_t *mutex;
+} MY_BITMAP;
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+extern void create_last_word_mask(MY_BITMAP *map);
+extern bool bitmap_init(MY_BITMAP *map, my_bitmap_map *buf, uint32_t n_bits,
+                           bool thread_safe);
+extern bool bitmap_is_clear_all(const MY_BITMAP *map);
+extern bool bitmap_is_prefix(const MY_BITMAP *map, uint32_t prefix_size);
+extern bool bitmap_is_set_all(const MY_BITMAP *map);
+extern bool bitmap_is_subset(const MY_BITMAP *map1, const MY_BITMAP *map2);
+extern bool bitmap_is_overlapping(const MY_BITMAP *map1,
+                                     const MY_BITMAP *map2);
+extern bool bitmap_test_and_set(MY_BITMAP *map, uint32_t bitmap_bit);
+extern bool bitmap_test_and_clear(MY_BITMAP *map, uint32_t bitmap_bit);
+extern bool bitmap_fast_test_and_clear(MY_BITMAP *map, uint32_t bitmap_bit);
+extern bool bitmap_fast_test_and_set(MY_BITMAP *map, uint32_t bitmap_bit);
+extern uint32_t bitmap_set_next(MY_BITMAP *map);
+extern uint32_t bitmap_get_first(const MY_BITMAP *map);
+extern uint32_t bitmap_get_first_set(const MY_BITMAP *map);
+extern uint32_t bitmap_bits_set(const MY_BITMAP *map);
+extern void bitmap_free(MY_BITMAP *map);
+extern void bitmap_set_above(MY_BITMAP *map, uint32_t from_byte, uint32_t use_bit);
+extern void bitmap_set_prefix(MY_BITMAP *map, uint32_t prefix_size);
+extern void bitmap_intersect(MY_BITMAP *map, const MY_BITMAP *map2);
+extern void bitmap_subtract(MY_BITMAP *map, const MY_BITMAP *map2);
+extern void bitmap_union(MY_BITMAP *map, const MY_BITMAP *map2);
+extern void bitmap_xor(MY_BITMAP *map, const MY_BITMAP *map2);
+extern void bitmap_invert(MY_BITMAP *map);
+extern void bitmap_copy(MY_BITMAP *map, const MY_BITMAP *map2);
+
+extern uint32_t bitmap_lock_set_next(MY_BITMAP *map);
+extern void bitmap_lock_clear_bit(MY_BITMAP *map, uint32_t bitmap_bit);
+#ifdef NOT_USED
+extern uint32_t bitmap_lock_bits_set(const MY_BITMAP *map);
+extern bool bitmap_lock_is_set_all(const MY_BITMAP *map);
+extern uint32_t bitmap_lock_get_first(const MY_BITMAP *map);
+extern uint32_t bitmap_lock_get_first_set(const MY_BITMAP *map);
+extern bool bitmap_lock_is_subset(const MY_BITMAP *map1,
+                                     const MY_BITMAP *map2);
+extern bool bitmap_lock_is_prefix(const MY_BITMAP *map, uint32_t prefix_size);
+extern bool bitmap_lock_is_set(const MY_BITMAP *map, uint32_t bitmap_bit);
+extern bool bitmap_lock_is_clear_all(const MY_BITMAP *map);
+extern bool bitmap_lock_cmp(const MY_BITMAP *map1, const MY_BITMAP *map2);
+extern void bitmap_lock_set_all(MY_BITMAP *map);
+extern void bitmap_lock_clear_all(MY_BITMAP *map);
+extern void bitmap_lock_set_bit(MY_BITMAP *map, uint32_t bitmap_bit);
+extern void bitmap_lock_flip_bit(MY_BITMAP *map, uint32_t bitmap_bit);
+extern void bitmap_lock_set_prefix(MY_BITMAP *map, uint32_t prefix_size);
+extern void bitmap_lock_intersect(MY_BITMAP *map, const MY_BITMAP *map2);
+extern void bitmap_lock_subtract(MY_BITMAP *map, const MY_BITMAP *map2);
+extern void bitmap_lock_union(MY_BITMAP *map, const MY_BITMAP *map2);
+extern void bitmap_lock_xor(MY_BITMAP *map, const MY_BITMAP *map2);
+extern void bitmap_lock_invert(MY_BITMAP *map);
+#endif
+/* Fast, not thread safe, bitmap functions */
+#define bitmap_buffer_size(bits) (((bits)+31)/32)*4
+#define no_bytes_in_map(map) (((map)->n_bits + 7)/8)
+#define no_words_in_map(map) (((map)->n_bits + 31)/32)
+#define bytes_word_aligned(bytes) (4*((bytes + 3)/4))
+#define _bitmap_set_bit(MAP, BIT) (((unsigned char*)(MAP)->bitmap)[(BIT) / 8] \
+                                  |= (1 << ((BIT) & 7)))
+#define _bitmap_flip_bit(MAP, BIT) (((unsigned char*)(MAP)->bitmap)[(BIT) / 8] \
+                                  ^= (1 << ((BIT) & 7)))
+#define _bitmap_clear_bit(MAP, BIT) (((unsigned char*)(MAP)->bitmap)[(BIT) / 8] \
+                                  &= ~ (1 << ((BIT) & 7)))
+#define _bitmap_is_set(MAP, BIT) (uint32_t) (((unsigned char*)(MAP)->bitmap)[(BIT) / 8] \
+                                         & (1 << ((BIT) & 7)))
+/*
+  NEVER use an increment/decrement operator with the 'bit' argument.
+
+  FORBIDDEN: bitmap_set_bit($my_bitmap, (field++)->field_index);
+*/
+#define bitmap_set_bit(MAP, BIT) _bitmap_set_bit(MAP, BIT)
+#define bitmap_flip_bit(MAP, BIT) _bitmap_flip_bit(MAP, BIT)
+#define bitmap_clear_bit(MAP, BIT) _bitmap_clear_bit(MAP, BIT)
+#define bitmap_is_set(MAP, BIT) _bitmap_is_set(MAP, BIT)
+
+static inline bool bitmap_cmp(const MY_BITMAP *map1, const MY_BITMAP *map2)
+{
+  *(map1)->last_word_ptr|= (map1)->last_word_mask;
+  *(map2)->last_word_ptr|= (map2)->last_word_mask;
+  return memcmp((map1)->bitmap, (map2)->bitmap, 4*no_words_in_map((map1)))==0;
+}
+
+#define bitmap_clear_all(MAP) \
+  { memset((MAP)->bitmap, 0, 4*no_words_in_map((MAP))); }
+#define bitmap_set_all(MAP) \
+  (memset((MAP)->bitmap, 0xFF, 4*no_words_in_map((MAP))))
+
+/**
+   check, set and clear a bit of interest of an integer.
+
+   If the bit is out of range @retval -1. Otherwise
+   bit_is_set   @return 0 or 1 reflecting the bit is set or not;
+   bit_do_set   @return 1 (bit is set 1)
+   bit_do_clear @return 0 (bit is cleared to 0)
+*/
+
+#define bit_is_set(I,B)   (sizeof(I) * CHAR_BIT > (B) ?                 \
+                           (((I) & (1UL << (B))) == 0 ? 0 : 1) : -1)
+#define bit_do_set(I,B)   (sizeof(I) * CHAR_BIT > (B) ?         \
+                           ((I) |= (1UL << (B)), 1) : -1)
+#define bit_do_clear(I,B) (sizeof(I) * CHAR_BIT > (B) ?         \
+                           ((I) &= ~(1UL << (B)), 0) : -1)
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif /* _my_bitmap_h_ */

=== modified file 'plugin/heap/ha_heap.cc'
--- plugin/heap/ha_heap.cc	2009-04-29 07:16:04 +0000
+++ plugin/heap/ha_heap.cc	2009-05-08 19:07:39 +0000
@@ -202,11 +202,11 @@
 
 void ha_heap::set_keys_for_scanning(void)
 {
-  btree_keys.reset();
+  btree_keys.clear_all();
   for (uint32_t i= 0 ; i < table->s->keys ; i++)
   {
     if (table->key_info[i].algorithm == HA_KEY_ALG_BTREE)
-      btree_keys.set(i);
+      btree_keys.set_bit(i);
   }
 }
 

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2009-05-04 23:54:28 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2009-05-08 19:07:39 +0000
@@ -3631,7 +3631,7 @@
 	}
 
 	n_fields = (ulint)table->s->fields; /* number of columns */
-	n_stored_fields= (ulint)table->s->fields; /* number of stored columns */
+	n_stored_fields= (ulint)table->s->stored_fields; /* number of stored columns */
 
 	if (!prebuilt->mysql_template) {
 		prebuilt->mysql_template = (mysql_row_templ_t*)
@@ -3663,6 +3663,8 @@
 	for (sql_idx = 0; sql_idx < n_fields; sql_idx++) {
 		templ = prebuilt->mysql_template + n_requested_fields;
 		field = table->field[sql_idx];
+		if (!field->is_stored)
+		       goto skip_field;
 
 		if (UNIV_LIKELY(templ_type == ROW_MYSQL_REC_FIELDS)) {
 			/* Decide which columns we should fetch
@@ -3670,7 +3672,7 @@
 			register const ibool	index_contains_field =
 				dict_index_contains_col_or_prefix(index, innodb_idx);
                         register const ibool    index_covers_field = 
-                                field->part_of_key.test(file->active_index);
+                                field->part_of_key.is_set(file->active_index);
 
 
 			if (!index_contains_field && prebuilt->read_just_key) {
@@ -3686,12 +3688,12 @@
 				goto include_field;
 			}
 
-                        if (field->isRead() || field->isWrite())
+                        if (table->read_set->test(sql_idx) ||
+                            table->write_set->test(sql_idx)) {
 				/* This field is needed in the query */
+
 				goto include_field;
-
-                        assert(table->read_set->test(sql_idx) == field->isRead());
-                        assert(table->write_set->test(sql_idx) == field->isWrite());
+			}
 
 			if (fetch_primary_key_cols
 				&& dict_table_col_in_clustered_key(
@@ -3764,7 +3766,10 @@
 			prebuilt->templ_contains_blob = TRUE;
 		}
 skip_field:
-                innodb_idx++;
+                if (field->is_stored)
+                {
+                  innodb_idx++;
+                }
 		if (need_second_pass && (sql_idx+1 == n_fields))
 		{
                   prebuilt->n_index_fields= n_requested_fields;
@@ -4253,6 +4258,8 @@
 
 	for (sql_idx = 0; sql_idx < n_fields; sql_idx++) {
 		field = table->field[sql_idx];
+		if (!field->is_stored)
+		  continue;
 
 		o_ptr = (const byte*) old_row + get_field_offset(table, field);
 		n_ptr = (const byte*) new_row + get_field_offset(table, field);
@@ -4347,7 +4354,8 @@
 				&prebuilt->table->cols[innodb_idx], clust_index);
 			n_changed++;
 		}
-                innodb_idx++;
+		if (field->is_stored)
+		  innodb_idx++;
 	}
 
 	uvect->n_fields = n_changed;
@@ -5330,7 +5338,7 @@
 	/* We pass 0 as the space id, and determine at a lower level the space
 	id where to store the table */
 
-	table = dict_mem_table_create(table_name, 0, form->s->fields, flags);
+	table = dict_mem_table_create(table_name, 0, form->s->stored_fields, flags);
 
 	if (path_of_temp_table) {
 		table->dir_path_of_temp_table =
@@ -5339,6 +5347,8 @@
 
 	for (i = 0; i < n_cols; i++) {
 		field = form->field[i];
+		if (!field->is_stored)
+		  continue;
 
 		col_type = get_innobase_type_from_mysql_type(&unsigned_type,
 									field);

=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2009-04-29 07:16:04 +0000
+++ plugin/myisam/ha_myisam.cc	2009-05-08 19:07:39 +0000
@@ -581,7 +581,7 @@
   if (file->s->options & (HA_OPTION_CHECKSUM | HA_OPTION_COMPRESS_RECORD))
     int_table_flags|=HA_HAS_CHECKSUM;
 
-  keys_with_parts.reset();
+  keys_with_parts.clear_all();
   for (i= 0; i < table->s->keys; i++)
   {
     table->key_info[i].block_size= file->s->keyinfo[i].block_length;
@@ -590,9 +590,9 @@
     KEY_PART_INFO *kp_end= kp + table->key_info[i].key_parts;
     for (; kp != kp_end; kp++)
     {
-      if (!kp->field->part_of_key.test(i))
+      if (!kp->field->part_of_key.is_set(i))
       {
-        keys_with_parts.set(i);
+        keys_with_parts.set_bit(i);
         break;
       }
     }
@@ -999,14 +999,19 @@
   KEY_CACHE *new_key_cache= check_opt->key_cache;
   const char *errmsg= 0;
   int error= HA_ADMIN_OK;
+  uint64_t map;
   TableList *table_list= table->pos_in_table_list;
 
-  table->keys_in_use_for_query.reset();
+  table->keys_in_use_for_query.clear_all();
 
   if (table_list->process_index_hints(table))
     return(HA_ADMIN_FAILED);
+  map= ~(uint64_t) 0;
+  if (!table->keys_in_use_for_query.is_clear_all())
+    /* use all keys if there's no list specified by the user through hints */
+    map= table->keys_in_use_for_query.to_uint64_t();
 
-  if ((error= mi_assign_to_key_cache(file, new_key_cache)))
+  if ((error= mi_assign_to_key_cache(file, map, new_key_cache)))
   {
     char buf[STRING_BUFFER_USUAL_SIZE];
     snprintf(buf, sizeof(buf),
@@ -1361,7 +1366,7 @@
   return ((table_share->key_info[inx].algorithm == HA_KEY_ALG_FULLTEXT) ?
           0 : HA_READ_NEXT | HA_READ_PREV | HA_READ_RANGE |
           HA_READ_ORDER | HA_KEYREAD_ONLY |
-          (keys_with_parts.test(inx)?0:HA_DO_INDEX_COND_PUSHDOWN));
+          (keys_with_parts.is_set(inx)?0:HA_DO_INDEX_COND_PUSHDOWN));
 }
 
 
@@ -1538,9 +1543,9 @@
     /* Update share */
     if (share->tmp_table == NO_TMP_TABLE)
       pthread_mutex_lock(&share->mutex);
-    set_prefix(share->keys_in_use, share->keys);
-    share->keys_in_use&= misam_info.key_map;
-    share->keys_for_keyread&= share->keys_in_use;
+    share->keys_in_use.set_prefix(share->keys);
+    share->keys_in_use.intersect_extended(misam_info.key_map);
+    share->keys_for_keyread.intersect(share->keys_in_use);
     share->db_record_offset= misam_info.record_offset;
     if (share->key_parts)
       memcpy(table->key_info[0].rec_per_key,

=== modified file 'plugin/myisam/mi_keycache.cc'
--- plugin/myisam/mi_keycache.cc	2009-04-25 18:00:37 +0000
+++ plugin/myisam/mi_keycache.cc	2009-05-08 19:07:39 +0000
@@ -27,6 +27,7 @@
   SYNOPSIS
     mi_assign_to_key_cache()
       info          open table
+      key_map       map of indexes to assign to the key cache
       key_cache_ptr pointer to the key cache handle
       assign_lock   Mutex to lock during assignment
 
@@ -39,14 +40,18 @@
 
   NOTES
     At present pages for all indexes must be assigned to the same key cache.
+    In future only pages for indexes specified in the key_map parameter
+    of the table will be assigned to the specified key cache.
 
   RETURN VALUE
     0  If a success
     #  Error code
 */
 
-int mi_assign_to_key_cache(MI_INFO *info, KEY_CACHE *key_cache) 
+int mi_assign_to_key_cache(MI_INFO *info, uint64_t key_map,
+			   KEY_CACHE *key_cache)
 {
+  (void)key_map;
   int error= 0;
   MYISAM_SHARE* share= info->s;
 
@@ -141,7 +146,7 @@
     MI_INFO *info= *it;
     MYISAM_SHARE *share= info->s;
     if (share->key_cache == old_key_cache)
-      mi_assign_to_key_cache(info, new_key_cache);
+      mi_assign_to_key_cache(info, UINT64_MAX, new_key_cache);
     ++it;
   }
 

=== modified file 'plugin/myisam/myisam.h'
--- plugin/myisam/myisam.h	2009-04-26 16:53:32 +0000
+++ plugin/myisam/myisam.h	2009-05-08 19:07:39 +0000
@@ -17,9 +17,6 @@
 
 #ifndef _myisam_h
 #define _myisam_h
-
-#include <drizzled/key_map.h>
-
 #ifdef	__cplusplus
 extern "C" {
 #endif
@@ -477,7 +474,8 @@
 int mi_init_bulk_insert(MI_INFO *info, uint32_t cache_size, ha_rows rows);
 void mi_flush_bulk_insert(MI_INFO *info, uint32_t inx);
 void mi_end_bulk_insert(MI_INFO *info);
-int mi_assign_to_key_cache(MI_INFO *info, KEY_CACHE *key_cache); 
+int mi_assign_to_key_cache(MI_INFO *info, uint64_t key_map,
+			   KEY_CACHE *key_cache);
 void mi_change_key_cache(KEY_CACHE *old_key_cache,
 			 KEY_CACHE *new_key_cache);
 int mi_preload(MI_INFO *info, uint64_t key_map, bool ignore_leaves);

